(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
	typeof define === 'function' && define.amd ? define(factory) :
	(global = global || self, global.AdFuel = factory());
}(this, function () { 'use strict';

	function createCommonjsModule(fn, module) {
		return module = { exports: {} }, fn(module, module.exports), module.exports;
	}

	var _global = createCommonjsModule(function (module) {
	// https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
	var global = module.exports = typeof window != 'undefined' && window.Math == Math
	  ? window : typeof self != 'undefined' && self.Math == Math ? self
	  // eslint-disable-next-line no-new-func
	  : Function('return this')();
	if (typeof __g == 'number') __g = global; // eslint-disable-line no-undef
	});

	var _core = createCommonjsModule(function (module) {
	var core = module.exports = { version: '2.6.9' };
	if (typeof __e == 'number') __e = core; // eslint-disable-line no-undef
	});
	var _core_1 = _core.version;

	var _aFunction = function (it) {
	  if (typeof it != 'function') throw TypeError(it + ' is not a function!');
	  return it;
	};

	// optional / simple context binding

	var _ctx = function (fn, that, length) {
	  _aFunction(fn);
	  if (that === undefined) return fn;
	  switch (length) {
	    case 1: return function (a) {
	      return fn.call(that, a);
	    };
	    case 2: return function (a, b) {
	      return fn.call(that, a, b);
	    };
	    case 3: return function (a, b, c) {
	      return fn.call(that, a, b, c);
	    };
	  }
	  return function (/* ...args */) {
	    return fn.apply(that, arguments);
	  };
	};

	var _isObject = function (it) {
	  return typeof it === 'object' ? it !== null : typeof it === 'function';
	};

	var _anObject = function (it) {
	  if (!_isObject(it)) throw TypeError(it + ' is not an object!');
	  return it;
	};

	var _fails = function (exec) {
	  try {
	    return !!exec();
	  } catch (e) {
	    return true;
	  }
	};

	// Thank's IE8 for his funny defineProperty
	var _descriptors = !_fails(function () {
	  return Object.defineProperty({}, 'a', { get: function () { return 7; } }).a != 7;
	});

	var document$1 = _global.document;
	// typeof document.createElement is 'object' in old IE
	var is = _isObject(document$1) && _isObject(document$1.createElement);
	var _domCreate = function (it) {
	  return is ? document$1.createElement(it) : {};
	};

	var _ie8DomDefine = !_descriptors && !_fails(function () {
	  return Object.defineProperty(_domCreate('div'), 'a', { get: function () { return 7; } }).a != 7;
	});

	// 7.1.1 ToPrimitive(input [, PreferredType])

	// instead of the ES6 spec version, we didn't implement @@toPrimitive case
	// and the second argument - flag - preferred type is a string
	var _toPrimitive = function (it, S) {
	  if (!_isObject(it)) return it;
	  var fn, val;
	  if (S && typeof (fn = it.toString) == 'function' && !_isObject(val = fn.call(it))) return val;
	  if (typeof (fn = it.valueOf) == 'function' && !_isObject(val = fn.call(it))) return val;
	  if (!S && typeof (fn = it.toString) == 'function' && !_isObject(val = fn.call(it))) return val;
	  throw TypeError("Can't convert object to primitive value");
	};

	var dP = Object.defineProperty;

	var f = _descriptors ? Object.defineProperty : function defineProperty(O, P, Attributes) {
	  _anObject(O);
	  P = _toPrimitive(P, true);
	  _anObject(Attributes);
	  if (_ie8DomDefine) try {
	    return dP(O, P, Attributes);
	  } catch (e) { /* empty */ }
	  if ('get' in Attributes || 'set' in Attributes) throw TypeError('Accessors not supported!');
	  if ('value' in Attributes) O[P] = Attributes.value;
	  return O;
	};

	var _objectDp = {
		f: f
	};

	var _propertyDesc = function (bitmap, value) {
	  return {
	    enumerable: !(bitmap & 1),
	    configurable: !(bitmap & 2),
	    writable: !(bitmap & 4),
	    value: value
	  };
	};

	var _hide = _descriptors ? function (object, key, value) {
	  return _objectDp.f(object, key, _propertyDesc(1, value));
	} : function (object, key, value) {
	  object[key] = value;
	  return object;
	};

	var hasOwnProperty = {}.hasOwnProperty;
	var _has = function (it, key) {
	  return hasOwnProperty.call(it, key);
	};

	var PROTOTYPE = 'prototype';

	var $export = function (type, name, source) {
	  var IS_FORCED = type & $export.F;
	  var IS_GLOBAL = type & $export.G;
	  var IS_STATIC = type & $export.S;
	  var IS_PROTO = type & $export.P;
	  var IS_BIND = type & $export.B;
	  var IS_WRAP = type & $export.W;
	  var exports = IS_GLOBAL ? _core : _core[name] || (_core[name] = {});
	  var expProto = exports[PROTOTYPE];
	  var target = IS_GLOBAL ? _global : IS_STATIC ? _global[name] : (_global[name] || {})[PROTOTYPE];
	  var key, own, out;
	  if (IS_GLOBAL) source = name;
	  for (key in source) {
	    // contains in native
	    own = !IS_FORCED && target && target[key] !== undefined;
	    if (own && _has(exports, key)) continue;
	    // export native or passed
	    out = own ? target[key] : source[key];
	    // prevent global pollution for namespaces
	    exports[key] = IS_GLOBAL && typeof target[key] != 'function' ? source[key]
	    // bind timers to global for call from export context
	    : IS_BIND && own ? _ctx(out, _global)
	    // wrap global constructors for prevent change them in library
	    : IS_WRAP && target[key] == out ? (function (C) {
	      var F = function (a, b, c) {
	        if (this instanceof C) {
	          switch (arguments.length) {
	            case 0: return new C();
	            case 1: return new C(a);
	            case 2: return new C(a, b);
	          } return new C(a, b, c);
	        } return C.apply(this, arguments);
	      };
	      F[PROTOTYPE] = C[PROTOTYPE];
	      return F;
	    // make static versions for prototype methods
	    })(out) : IS_PROTO && typeof out == 'function' ? _ctx(Function.call, out) : out;
	    // export proto methods to core.%CONSTRUCTOR%.methods.%NAME%
	    if (IS_PROTO) {
	      (exports.virtual || (exports.virtual = {}))[key] = out;
	      // export proto methods to core.%CONSTRUCTOR%.prototype.%NAME%
	      if (type & $export.R && expProto && !expProto[key]) _hide(expProto, key, out);
	    }
	  }
	};
	// type bitmap
	$export.F = 1;   // forced
	$export.G = 2;   // global
	$export.S = 4;   // static
	$export.P = 8;   // proto
	$export.B = 16;  // bind
	$export.W = 32;  // wrap
	$export.U = 64;  // safe
	$export.R = 128; // real proto method for `library`
	var _export = $export;

	// 20.3.3.1 / 15.9.4.4 Date.now()


	_export(_export.S, 'Date', { now: function () { return new Date().getTime(); } });

	var now = _core.Date.now;

	var now$1 = now;

	// 7.2.1 RequireObjectCoercible(argument)
	var _defined = function (it) {
	  if (it == undefined) throw TypeError("Can't call method on  " + it);
	  return it;
	};

	var _stringWs = '\x09\x0A\x0B\x0C\x0D\x20\xA0\u1680\u180E\u2000\u2001\u2002\u2003' +
	  '\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF';

	var space = '[' + _stringWs + ']';
	var non = '\u200b\u0085';
	var ltrim = RegExp('^' + space + space + '*');
	var rtrim = RegExp(space + space + '*$');

	var exporter = function (KEY, exec, ALIAS) {
	  var exp = {};
	  var FORCE = _fails(function () {
	    return !!_stringWs[KEY]() || non[KEY]() != non;
	  });
	  var fn = exp[KEY] = FORCE ? exec(trim) : _stringWs[KEY];
	  if (ALIAS) exp[ALIAS] = fn;
	  _export(_export.P + _export.F * FORCE, 'String', exp);
	};

	// 1 -> String#trimLeft
	// 2 -> String#trimRight
	// 3 -> String#trim
	var trim = exporter.trim = function (string, TYPE) {
	  string = String(_defined(string));
	  if (TYPE & 1) string = string.replace(ltrim, '');
	  if (TYPE & 2) string = string.replace(rtrim, '');
	  return string;
	};

	var _stringTrim = exporter;

	var $parseInt = _global.parseInt;
	var $trim = _stringTrim.trim;

	var hex = /^[-+]?0[xX]/;

	var _parseInt = $parseInt(_stringWs + '08') !== 8 || $parseInt(_stringWs + '0x16') !== 22 ? function parseInt(str, radix) {
	  var string = $trim(String(str), 3);
	  return $parseInt(string, (radix >>> 0) || (hex.test(string) ? 16 : 10));
	} : $parseInt;

	// 18.2.5 parseInt(string, radix)
	_export(_export.G + _export.F * (parseInt != _parseInt), { parseInt: _parseInt });

	var _parseInt$1 = _core.parseInt;

	var _parseInt$2 = _parseInt$1;

	var $parseFloat = _global.parseFloat;
	var $trim$1 = _stringTrim.trim;

	var _parseFloat = 1 / $parseFloat(_stringWs + '-0') !== -Infinity ? function parseFloat(str) {
	  var string = $trim$1(String(str), 3);
	  var result = $parseFloat(string);
	  return result === 0 && string.charAt(0) == '-' ? -0 : result;
	} : $parseFloat;

	// 18.2.4 parseFloat(string)
	_export(_export.G + _export.F * (parseFloat != _parseFloat), { parseFloat: _parseFloat });

	var _parseFloat$1 = _core.parseFloat;

	var _parseFloat$2 = _parseFloat$1;

	// most Object methods by ES6 should accept primitives



	var _objectSap = function (KEY, exec) {
	  var fn = (_core.Object || {})[KEY] || Object[KEY];
	  var exp = {};
	  exp[KEY] = exec(fn);
	  _export(_export.S + _export.F * _fails(function () { fn(1); }), 'Object', exp);
	};

	var toString = {}.toString;

	var _cof = function (it) {
	  return toString.call(it).slice(8, -1);
	};

	// fallback for non-array-like ES3 and non-enumerable old V8 strings

	// eslint-disable-next-line no-prototype-builtins
	var _iobject = Object('z').propertyIsEnumerable(0) ? Object : function (it) {
	  return _cof(it) == 'String' ? it.split('') : Object(it);
	};

	// to indexed object, toObject with fallback for non-array-like ES3 strings


	var _toIobject = function (it) {
	  return _iobject(_defined(it));
	};

	// 7.1.4 ToInteger
	var ceil = Math.ceil;
	var floor = Math.floor;
	var _toInteger = function (it) {
	  return isNaN(it = +it) ? 0 : (it > 0 ? floor : ceil)(it);
	};

	// 7.1.15 ToLength

	var min = Math.min;
	var _toLength = function (it) {
	  return it > 0 ? min(_toInteger(it), 0x1fffffffffffff) : 0; // pow(2, 53) - 1 == 9007199254740991
	};

	var max = Math.max;
	var min$1 = Math.min;
	var _toAbsoluteIndex = function (index, length) {
	  index = _toInteger(index);
	  return index < 0 ? max(index + length, 0) : min$1(index, length);
	};

	// false -> Array#indexOf
	// true  -> Array#includes



	var _arrayIncludes = function (IS_INCLUDES) {
	  return function ($this, el, fromIndex) {
	    var O = _toIobject($this);
	    var length = _toLength(O.length);
	    var index = _toAbsoluteIndex(fromIndex, length);
	    var value;
	    // Array#includes uses SameValueZero equality algorithm
	    // eslint-disable-next-line no-self-compare
	    if (IS_INCLUDES && el != el) while (length > index) {
	      value = O[index++];
	      // eslint-disable-next-line no-self-compare
	      if (value != value) return true;
	    // Array#indexOf ignores holes, Array#includes - not
	    } else for (;length > index; index++) if (IS_INCLUDES || index in O) {
	      if (O[index] === el) return IS_INCLUDES || index || 0;
	    } return !IS_INCLUDES && -1;
	  };
	};

	var _library = true;

	var _shared = createCommonjsModule(function (module) {
	var SHARED = '__core-js_shared__';
	var store = _global[SHARED] || (_global[SHARED] = {});

	(module.exports = function (key, value) {
	  return store[key] || (store[key] = value !== undefined ? value : {});
	})('versions', []).push({
	  version: _core.version,
	  mode:  'pure' ,
	  copyright: '© 2019 Denis Pushkarev (zloirock.ru)'
	});
	});

	var id = 0;
	var px = Math.random();
	var _uid = function (key) {
	  return 'Symbol('.concat(key === undefined ? '' : key, ')_', (++id + px).toString(36));
	};

	var shared = _shared('keys');

	var _sharedKey = function (key) {
	  return shared[key] || (shared[key] = _uid(key));
	};

	var arrayIndexOf = _arrayIncludes(false);
	var IE_PROTO = _sharedKey('IE_PROTO');

	var _objectKeysInternal = function (object, names) {
	  var O = _toIobject(object);
	  var i = 0;
	  var result = [];
	  var key;
	  for (key in O) if (key != IE_PROTO) _has(O, key) && result.push(key);
	  // Don't enum bug & hidden keys
	  while (names.length > i) if (_has(O, key = names[i++])) {
	    ~arrayIndexOf(result, key) || result.push(key);
	  }
	  return result;
	};

	// IE 8- don't enum bug keys
	var _enumBugKeys = (
	  'constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf'
	).split(',');

	// 19.1.2.7 / 15.2.3.4 Object.getOwnPropertyNames(O)

	var hiddenKeys = _enumBugKeys.concat('length', 'prototype');

	var f$1 = Object.getOwnPropertyNames || function getOwnPropertyNames(O) {
	  return _objectKeysInternal(O, hiddenKeys);
	};

	var _objectGopn = {
		f: f$1
	};

	// fallback for IE11 buggy Object.getOwnPropertyNames with iframe and window

	var gOPN = _objectGopn.f;
	var toString$1 = {}.toString;

	var windowNames = typeof window == 'object' && window && Object.getOwnPropertyNames
	  ? Object.getOwnPropertyNames(window) : [];

	var getWindowNames = function (it) {
	  try {
	    return gOPN(it);
	  } catch (e) {
	    return windowNames.slice();
	  }
	};

	var f$2 = function getOwnPropertyNames(it) {
	  return windowNames && toString$1.call(it) == '[object Window]' ? getWindowNames(it) : gOPN(_toIobject(it));
	};

	var _objectGopnExt = {
		f: f$2
	};

	// 19.1.2.7 Object.getOwnPropertyNames(O)
	_objectSap('getOwnPropertyNames', function () {
	  return _objectGopnExt.f;
	});

	var $Object = _core.Object;
	var getOwnPropertyNames = function getOwnPropertyNames(it) {
	  return $Object.getOwnPropertyNames(it);
	};

	var getOwnPropertyNames$1 = getOwnPropertyNames;

	// 7.1.13 ToObject(argument)

	var _toObject = function (it) {
	  return Object(_defined(it));
	};

	// 19.1.2.14 / 15.2.3.14 Object.keys(O)



	var _objectKeys = Object.keys || function keys(O) {
	  return _objectKeysInternal(O, _enumBugKeys);
	};

	// 19.1.2.14 Object.keys(O)



	_objectSap('keys', function () {
	  return function keys(it) {
	    return _objectKeys(_toObject(it));
	  };
	});

	var keys = _core.Object.keys;

	var keys$1 = keys;

	// true  -> String#at
	// false -> String#codePointAt
	var _stringAt = function (TO_STRING) {
	  return function (that, pos) {
	    var s = String(_defined(that));
	    var i = _toInteger(pos);
	    var l = s.length;
	    var a, b;
	    if (i < 0 || i >= l) return TO_STRING ? '' : undefined;
	    a = s.charCodeAt(i);
	    return a < 0xd800 || a > 0xdbff || i + 1 === l || (b = s.charCodeAt(i + 1)) < 0xdc00 || b > 0xdfff
	      ? TO_STRING ? s.charAt(i) : a
	      : TO_STRING ? s.slice(i, i + 2) : (a - 0xd800 << 10) + (b - 0xdc00) + 0x10000;
	  };
	};

	var _redefine = _hide;

	var _iterators = {};

	var _objectDps = _descriptors ? Object.defineProperties : function defineProperties(O, Properties) {
	  _anObject(O);
	  var keys = _objectKeys(Properties);
	  var length = keys.length;
	  var i = 0;
	  var P;
	  while (length > i) _objectDp.f(O, P = keys[i++], Properties[P]);
	  return O;
	};

	var document$2 = _global.document;
	var _html = document$2 && document$2.documentElement;

	// 19.1.2.2 / 15.2.3.5 Object.create(O [, Properties])



	var IE_PROTO$1 = _sharedKey('IE_PROTO');
	var Empty = function () { /* empty */ };
	var PROTOTYPE$1 = 'prototype';

	// Create object with fake `null` prototype: use iframe Object with cleared prototype
	var createDict = function () {
	  // Thrash, waste and sodomy: IE GC bug
	  var iframe = _domCreate('iframe');
	  var i = _enumBugKeys.length;
	  var lt = '<';
	  var gt = '>';
	  var iframeDocument;
	  iframe.style.display = 'none';
	  _html.appendChild(iframe);
	  iframe.src = 'javascript:'; // eslint-disable-line no-script-url
	  // createDict = iframe.contentWindow.Object;
	  // html.removeChild(iframe);
	  iframeDocument = iframe.contentWindow.document;
	  iframeDocument.open();
	  iframeDocument.write(lt + 'script' + gt + 'document.F=Object' + lt + '/script' + gt);
	  iframeDocument.close();
	  createDict = iframeDocument.F;
	  while (i--) delete createDict[PROTOTYPE$1][_enumBugKeys[i]];
	  return createDict();
	};

	var _objectCreate = Object.create || function create(O, Properties) {
	  var result;
	  if (O !== null) {
	    Empty[PROTOTYPE$1] = _anObject(O);
	    result = new Empty();
	    Empty[PROTOTYPE$1] = null;
	    // add "__proto__" for Object.getPrototypeOf polyfill
	    result[IE_PROTO$1] = O;
	  } else result = createDict();
	  return Properties === undefined ? result : _objectDps(result, Properties);
	};

	var _wks = createCommonjsModule(function (module) {
	var store = _shared('wks');

	var Symbol = _global.Symbol;
	var USE_SYMBOL = typeof Symbol == 'function';

	var $exports = module.exports = function (name) {
	  return store[name] || (store[name] =
	    USE_SYMBOL && Symbol[name] || (USE_SYMBOL ? Symbol : _uid)('Symbol.' + name));
	};

	$exports.store = store;
	});

	var def = _objectDp.f;

	var TAG = _wks('toStringTag');

	var _setToStringTag = function (it, tag, stat) {
	  if (it && !_has(it = stat ? it : it.prototype, TAG)) def(it, TAG, { configurable: true, value: tag });
	};

	var IteratorPrototype = {};

	// 25.1.2.1.1 %IteratorPrototype%[@@iterator]()
	_hide(IteratorPrototype, _wks('iterator'), function () { return this; });

	var _iterCreate = function (Constructor, NAME, next) {
	  Constructor.prototype = _objectCreate(IteratorPrototype, { next: _propertyDesc(1, next) });
	  _setToStringTag(Constructor, NAME + ' Iterator');
	};

	// 19.1.2.9 / 15.2.3.2 Object.getPrototypeOf(O)


	var IE_PROTO$2 = _sharedKey('IE_PROTO');
	var ObjectProto = Object.prototype;

	var _objectGpo = Object.getPrototypeOf || function (O) {
	  O = _toObject(O);
	  if (_has(O, IE_PROTO$2)) return O[IE_PROTO$2];
	  if (typeof O.constructor == 'function' && O instanceof O.constructor) {
	    return O.constructor.prototype;
	  } return O instanceof Object ? ObjectProto : null;
	};

	var ITERATOR = _wks('iterator');
	var BUGGY = !([].keys && 'next' in [].keys()); // Safari has buggy iterators w/o `next`
	var FF_ITERATOR = '@@iterator';
	var KEYS = 'keys';
	var VALUES = 'values';

	var returnThis = function () { return this; };

	var _iterDefine = function (Base, NAME, Constructor, next, DEFAULT, IS_SET, FORCED) {
	  _iterCreate(Constructor, NAME, next);
	  var getMethod = function (kind) {
	    if (!BUGGY && kind in proto) return proto[kind];
	    switch (kind) {
	      case KEYS: return function keys() { return new Constructor(this, kind); };
	      case VALUES: return function values() { return new Constructor(this, kind); };
	    } return function entries() { return new Constructor(this, kind); };
	  };
	  var TAG = NAME + ' Iterator';
	  var DEF_VALUES = DEFAULT == VALUES;
	  var VALUES_BUG = false;
	  var proto = Base.prototype;
	  var $native = proto[ITERATOR] || proto[FF_ITERATOR] || DEFAULT && proto[DEFAULT];
	  var $default = $native || getMethod(DEFAULT);
	  var $entries = DEFAULT ? !DEF_VALUES ? $default : getMethod('entries') : undefined;
	  var $anyNative = NAME == 'Array' ? proto.entries || $native : $native;
	  var methods, key, IteratorPrototype;
	  // Fix native
	  if ($anyNative) {
	    IteratorPrototype = _objectGpo($anyNative.call(new Base()));
	    if (IteratorPrototype !== Object.prototype && IteratorPrototype.next) {
	      // Set @@toStringTag to native iterators
	      _setToStringTag(IteratorPrototype, TAG, true);
	    }
	  }
	  // fix Array#{values, @@iterator}.name in V8 / FF
	  if (DEF_VALUES && $native && $native.name !== VALUES) {
	    VALUES_BUG = true;
	    $default = function values() { return $native.call(this); };
	  }
	  // Define iterator
	  if (( FORCED) && (BUGGY || VALUES_BUG || !proto[ITERATOR])) {
	    _hide(proto, ITERATOR, $default);
	  }
	  // Plug for library
	  _iterators[NAME] = $default;
	  _iterators[TAG] = returnThis;
	  if (DEFAULT) {
	    methods = {
	      values: DEF_VALUES ? $default : getMethod(VALUES),
	      keys: IS_SET ? $default : getMethod(KEYS),
	      entries: $entries
	    };
	    if (FORCED) for (key in methods) {
	      if (!(key in proto)) _redefine(proto, key, methods[key]);
	    } else _export(_export.P + _export.F * (BUGGY || VALUES_BUG), NAME, methods);
	  }
	  return methods;
	};

	var $at = _stringAt(true);

	// 21.1.3.27 String.prototype[@@iterator]()
	_iterDefine(String, 'String', function (iterated) {
	  this._t = String(iterated); // target
	  this._i = 0;                // next index
	// 21.1.5.2.1 %StringIteratorPrototype%.next()
	}, function () {
	  var O = this._t;
	  var index = this._i;
	  var point;
	  if (index >= O.length) return { value: undefined, done: true };
	  point = $at(O, index);
	  this._i += point.length;
	  return { value: point, done: false };
	});

	var _iterStep = function (done, value) {
	  return { value: value, done: !!done };
	};

	// 22.1.3.4 Array.prototype.entries()
	// 22.1.3.13 Array.prototype.keys()
	// 22.1.3.29 Array.prototype.values()
	// 22.1.3.30 Array.prototype[@@iterator]()
	var es6_array_iterator = _iterDefine(Array, 'Array', function (iterated, kind) {
	  this._t = _toIobject(iterated); // target
	  this._i = 0;                   // next index
	  this._k = kind;                // kind
	// 22.1.5.2.1 %ArrayIteratorPrototype%.next()
	}, function () {
	  var O = this._t;
	  var kind = this._k;
	  var index = this._i++;
	  if (!O || index >= O.length) {
	    this._t = undefined;
	    return _iterStep(1);
	  }
	  if (kind == 'keys') return _iterStep(0, index);
	  if (kind == 'values') return _iterStep(0, O[index]);
	  return _iterStep(0, [index, O[index]]);
	}, 'values');

	// argumentsList[@@iterator] is %ArrayProto_values% (9.4.4.6, 9.4.4.7)
	_iterators.Arguments = _iterators.Array;

	var TO_STRING_TAG = _wks('toStringTag');

	var DOMIterables = ('CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,' +
	  'DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,' +
	  'MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,' +
	  'SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,' +
	  'TextTrackList,TouchList').split(',');

	for (var i = 0; i < DOMIterables.length; i++) {
	  var NAME = DOMIterables[i];
	  var Collection = _global[NAME];
	  var proto = Collection && Collection.prototype;
	  if (proto && !proto[TO_STRING_TAG]) _hide(proto, TO_STRING_TAG, NAME);
	  _iterators[NAME] = _iterators.Array;
	}

	// getting tag from 19.1.3.6 Object.prototype.toString()

	var TAG$1 = _wks('toStringTag');
	// ES3 wrong here
	var ARG = _cof(function () { return arguments; }()) == 'Arguments';

	// fallback for IE11 Script Access Denied error
	var tryGet = function (it, key) {
	  try {
	    return it[key];
	  } catch (e) { /* empty */ }
	};

	var _classof = function (it) {
	  var O, T, B;
	  return it === undefined ? 'Undefined' : it === null ? 'Null'
	    // @@toStringTag case
	    : typeof (T = tryGet(O = Object(it), TAG$1)) == 'string' ? T
	    // builtinTag case
	    : ARG ? _cof(O)
	    // ES3 arguments fallback
	    : (B = _cof(O)) == 'Object' && typeof O.callee == 'function' ? 'Arguments' : B;
	};

	var _anInstance = function (it, Constructor, name, forbiddenField) {
	  if (!(it instanceof Constructor) || (forbiddenField !== undefined && forbiddenField in it)) {
	    throw TypeError(name + ': incorrect invocation!');
	  } return it;
	};

	// call something on iterator step with safe closing on error

	var _iterCall = function (iterator, fn, value, entries) {
	  try {
	    return entries ? fn(_anObject(value)[0], value[1]) : fn(value);
	  // 7.4.6 IteratorClose(iterator, completion)
	  } catch (e) {
	    var ret = iterator['return'];
	    if (ret !== undefined) _anObject(ret.call(iterator));
	    throw e;
	  }
	};

	// check on default Array iterator

	var ITERATOR$1 = _wks('iterator');
	var ArrayProto = Array.prototype;

	var _isArrayIter = function (it) {
	  return it !== undefined && (_iterators.Array === it || ArrayProto[ITERATOR$1] === it);
	};

	var ITERATOR$2 = _wks('iterator');

	var core_getIteratorMethod = _core.getIteratorMethod = function (it) {
	  if (it != undefined) return it[ITERATOR$2]
	    || it['@@iterator']
	    || _iterators[_classof(it)];
	};

	var _forOf = createCommonjsModule(function (module) {
	var BREAK = {};
	var RETURN = {};
	var exports = module.exports = function (iterable, entries, fn, that, ITERATOR) {
	  var iterFn = ITERATOR ? function () { return iterable; } : core_getIteratorMethod(iterable);
	  var f = _ctx(fn, that, entries ? 2 : 1);
	  var index = 0;
	  var length, step, iterator, result;
	  if (typeof iterFn != 'function') throw TypeError(iterable + ' is not iterable!');
	  // fast case for arrays with default iterator
	  if (_isArrayIter(iterFn)) for (length = _toLength(iterable.length); length > index; index++) {
	    result = entries ? f(_anObject(step = iterable[index])[0], step[1]) : f(iterable[index]);
	    if (result === BREAK || result === RETURN) return result;
	  } else for (iterator = iterFn.call(iterable); !(step = iterator.next()).done;) {
	    result = _iterCall(iterator, f, step.value, entries);
	    if (result === BREAK || result === RETURN) return result;
	  }
	};
	exports.BREAK = BREAK;
	exports.RETURN = RETURN;
	});

	// 7.3.20 SpeciesConstructor(O, defaultConstructor)


	var SPECIES = _wks('species');
	var _speciesConstructor = function (O, D) {
	  var C = _anObject(O).constructor;
	  var S;
	  return C === undefined || (S = _anObject(C)[SPECIES]) == undefined ? D : _aFunction(S);
	};

	// fast apply, http://jsperf.lnkit.com/fast-apply/5
	var _invoke = function (fn, args, that) {
	  var un = that === undefined;
	  switch (args.length) {
	    case 0: return un ? fn()
	                      : fn.call(that);
	    case 1: return un ? fn(args[0])
	                      : fn.call(that, args[0]);
	    case 2: return un ? fn(args[0], args[1])
	                      : fn.call(that, args[0], args[1]);
	    case 3: return un ? fn(args[0], args[1], args[2])
	                      : fn.call(that, args[0], args[1], args[2]);
	    case 4: return un ? fn(args[0], args[1], args[2], args[3])
	                      : fn.call(that, args[0], args[1], args[2], args[3]);
	  } return fn.apply(that, args);
	};

	var process = _global.process;
	var setTask = _global.setImmediate;
	var clearTask = _global.clearImmediate;
	var MessageChannel = _global.MessageChannel;
	var Dispatch = _global.Dispatch;
	var counter = 0;
	var queue = {};
	var ONREADYSTATECHANGE = 'onreadystatechange';
	var defer, channel, port;
	var run = function () {
	  var id = +this;
	  // eslint-disable-next-line no-prototype-builtins
	  if (queue.hasOwnProperty(id)) {
	    var fn = queue[id];
	    delete queue[id];
	    fn();
	  }
	};
	var listener = function (event) {
	  run.call(event.data);
	};
	// Node.js 0.9+ & IE10+ has setImmediate, otherwise:
	if (!setTask || !clearTask) {
	  setTask = function setImmediate(fn) {
	    var args = [];
	    var i = 1;
	    while (arguments.length > i) args.push(arguments[i++]);
	    queue[++counter] = function () {
	      // eslint-disable-next-line no-new-func
	      _invoke(typeof fn == 'function' ? fn : Function(fn), args);
	    };
	    defer(counter);
	    return counter;
	  };
	  clearTask = function clearImmediate(id) {
	    delete queue[id];
	  };
	  // Node.js 0.8-
	  if (_cof(process) == 'process') {
	    defer = function (id) {
	      process.nextTick(_ctx(run, id, 1));
	    };
	  // Sphere (JS game engine) Dispatch API
	  } else if (Dispatch && Dispatch.now) {
	    defer = function (id) {
	      Dispatch.now(_ctx(run, id, 1));
	    };
	  // Browsers with MessageChannel, includes WebWorkers
	  } else if (MessageChannel) {
	    channel = new MessageChannel();
	    port = channel.port2;
	    channel.port1.onmessage = listener;
	    defer = _ctx(port.postMessage, port, 1);
	  // Browsers with postMessage, skip WebWorkers
	  // IE8 has postMessage, but it's sync & typeof its postMessage is 'object'
	  } else if (_global.addEventListener && typeof postMessage == 'function' && !_global.importScripts) {
	    defer = function (id) {
	      _global.postMessage(id + '', '*');
	    };
	    _global.addEventListener('message', listener, false);
	  // IE8-
	  } else if (ONREADYSTATECHANGE in _domCreate('script')) {
	    defer = function (id) {
	      _html.appendChild(_domCreate('script'))[ONREADYSTATECHANGE] = function () {
	        _html.removeChild(this);
	        run.call(id);
	      };
	    };
	  // Rest old browsers
	  } else {
	    defer = function (id) {
	      setTimeout(_ctx(run, id, 1), 0);
	    };
	  }
	}
	var _task = {
	  set: setTask,
	  clear: clearTask
	};

	var macrotask = _task.set;
	var Observer = _global.MutationObserver || _global.WebKitMutationObserver;
	var process$1 = _global.process;
	var Promise = _global.Promise;
	var isNode = _cof(process$1) == 'process';

	var _microtask = function () {
	  var head, last, notify;

	  var flush = function () {
	    var parent, fn;
	    if (isNode && (parent = process$1.domain)) parent.exit();
	    while (head) {
	      fn = head.fn;
	      head = head.next;
	      try {
	        fn();
	      } catch (e) {
	        if (head) notify();
	        else last = undefined;
	        throw e;
	      }
	    } last = undefined;
	    if (parent) parent.enter();
	  };

	  // Node.js
	  if (isNode) {
	    notify = function () {
	      process$1.nextTick(flush);
	    };
	  // browsers with MutationObserver, except iOS Safari - https://github.com/zloirock/core-js/issues/339
	  } else if (Observer && !(_global.navigator && _global.navigator.standalone)) {
	    var toggle = true;
	    var node = document.createTextNode('');
	    new Observer(flush).observe(node, { characterData: true }); // eslint-disable-line no-new
	    notify = function () {
	      node.data = toggle = !toggle;
	    };
	  // environments with maybe non-completely correct, but existent Promise
	  } else if (Promise && Promise.resolve) {
	    // Promise.resolve without an argument throws an error in LG WebOS 2
	    var promise = Promise.resolve(undefined);
	    notify = function () {
	      promise.then(flush);
	    };
	  // for other environments - macrotask based on:
	  // - setImmediate
	  // - MessageChannel
	  // - window.postMessag
	  // - onreadystatechange
	  // - setTimeout
	  } else {
	    notify = function () {
	      // strange IE + webpack dev server bug - use .call(global)
	      macrotask.call(_global, flush);
	    };
	  }

	  return function (fn) {
	    var task = { fn: fn, next: undefined };
	    if (last) last.next = task;
	    if (!head) {
	      head = task;
	      notify();
	    } last = task;
	  };
	};

	// 25.4.1.5 NewPromiseCapability(C)


	function PromiseCapability(C) {
	  var resolve, reject;
	  this.promise = new C(function ($$resolve, $$reject) {
	    if (resolve !== undefined || reject !== undefined) throw TypeError('Bad Promise constructor');
	    resolve = $$resolve;
	    reject = $$reject;
	  });
	  this.resolve = _aFunction(resolve);
	  this.reject = _aFunction(reject);
	}

	var f$3 = function (C) {
	  return new PromiseCapability(C);
	};

	var _newPromiseCapability = {
		f: f$3
	};

	var _perform = function (exec) {
	  try {
	    return { e: false, v: exec() };
	  } catch (e) {
	    return { e: true, v: e };
	  }
	};

	var navigator = _global.navigator;

	var _userAgent = navigator && navigator.userAgent || '';

	var _promiseResolve = function (C, x) {
	  _anObject(C);
	  if (_isObject(x) && x.constructor === C) return x;
	  var promiseCapability = _newPromiseCapability.f(C);
	  var resolve = promiseCapability.resolve;
	  resolve(x);
	  return promiseCapability.promise;
	};

	var _redefineAll = function (target, src, safe) {
	  for (var key in src) {
	    if (safe && target[key]) target[key] = src[key];
	    else _hide(target, key, src[key]);
	  } return target;
	};

	var SPECIES$1 = _wks('species');

	var _setSpecies = function (KEY) {
	  var C = typeof _core[KEY] == 'function' ? _core[KEY] : _global[KEY];
	  if (_descriptors && C && !C[SPECIES$1]) _objectDp.f(C, SPECIES$1, {
	    configurable: true,
	    get: function () { return this; }
	  });
	};

	var ITERATOR$3 = _wks('iterator');
	var SAFE_CLOSING = false;

	try {
	  var riter = [7][ITERATOR$3]();
	  riter['return'] = function () { SAFE_CLOSING = true; };
	  // eslint-disable-next-line no-throw-literal
	  Array.from(riter, function () { throw 2; });
	} catch (e) { /* empty */ }

	var _iterDetect = function (exec, skipClosing) {
	  if (!skipClosing && !SAFE_CLOSING) return false;
	  var safe = false;
	  try {
	    var arr = [7];
	    var iter = arr[ITERATOR$3]();
	    iter.next = function () { return { done: safe = true }; };
	    arr[ITERATOR$3] = function () { return iter; };
	    exec(arr);
	  } catch (e) { /* empty */ }
	  return safe;
	};

	var task = _task.set;
	var microtask = _microtask();




	var PROMISE = 'Promise';
	var TypeError$1 = _global.TypeError;
	var process$2 = _global.process;
	var versions = process$2 && process$2.versions;
	var v8 = versions && versions.v8 || '';
	var $Promise = _global[PROMISE];
	var isNode$1 = _classof(process$2) == 'process';
	var empty = function () { /* empty */ };
	var Internal, newGenericPromiseCapability, OwnPromiseCapability, Wrapper;
	var newPromiseCapability = newGenericPromiseCapability = _newPromiseCapability.f;

	var USE_NATIVE = !!function () {
	  try {
	    // correct subclassing with @@species support
	    var promise = $Promise.resolve(1);
	    var FakePromise = (promise.constructor = {})[_wks('species')] = function (exec) {
	      exec(empty, empty);
	    };
	    // unhandled rejections tracking support, NodeJS Promise without it fails @@species test
	    return (isNode$1 || typeof PromiseRejectionEvent == 'function')
	      && promise.then(empty) instanceof FakePromise
	      // v8 6.6 (Node 10 and Chrome 66) have a bug with resolving custom thenables
	      // https://bugs.chromium.org/p/chromium/issues/detail?id=830565
	      // we can't detect it synchronously, so just check versions
	      && v8.indexOf('6.6') !== 0
	      && _userAgent.indexOf('Chrome/66') === -1;
	  } catch (e) { /* empty */ }
	}();

	// helpers
	var isThenable = function (it) {
	  var then;
	  return _isObject(it) && typeof (then = it.then) == 'function' ? then : false;
	};
	var notify = function (promise, isReject) {
	  if (promise._n) return;
	  promise._n = true;
	  var chain = promise._c;
	  microtask(function () {
	    var value = promise._v;
	    var ok = promise._s == 1;
	    var i = 0;
	    var run = function (reaction) {
	      var handler = ok ? reaction.ok : reaction.fail;
	      var resolve = reaction.resolve;
	      var reject = reaction.reject;
	      var domain = reaction.domain;
	      var result, then, exited;
	      try {
	        if (handler) {
	          if (!ok) {
	            if (promise._h == 2) onHandleUnhandled(promise);
	            promise._h = 1;
	          }
	          if (handler === true) result = value;
	          else {
	            if (domain) domain.enter();
	            result = handler(value); // may throw
	            if (domain) {
	              domain.exit();
	              exited = true;
	            }
	          }
	          if (result === reaction.promise) {
	            reject(TypeError$1('Promise-chain cycle'));
	          } else if (then = isThenable(result)) {
	            then.call(result, resolve, reject);
	          } else resolve(result);
	        } else reject(value);
	      } catch (e) {
	        if (domain && !exited) domain.exit();
	        reject(e);
	      }
	    };
	    while (chain.length > i) run(chain[i++]); // variable length - can't use forEach
	    promise._c = [];
	    promise._n = false;
	    if (isReject && !promise._h) onUnhandled(promise);
	  });
	};
	var onUnhandled = function (promise) {
	  task.call(_global, function () {
	    var value = promise._v;
	    var unhandled = isUnhandled(promise);
	    var result, handler, console;
	    if (unhandled) {
	      result = _perform(function () {
	        if (isNode$1) {
	          process$2.emit('unhandledRejection', value, promise);
	        } else if (handler = _global.onunhandledrejection) {
	          handler({ promise: promise, reason: value });
	        } else if ((console = _global.console) && console.error) {
	          console.error('Unhandled promise rejection', value);
	        }
	      });
	      // Browsers should not trigger `rejectionHandled` event if it was handled here, NodeJS - should
	      promise._h = isNode$1 || isUnhandled(promise) ? 2 : 1;
	    } promise._a = undefined;
	    if (unhandled && result.e) throw result.v;
	  });
	};
	var isUnhandled = function (promise) {
	  return promise._h !== 1 && (promise._a || promise._c).length === 0;
	};
	var onHandleUnhandled = function (promise) {
	  task.call(_global, function () {
	    var handler;
	    if (isNode$1) {
	      process$2.emit('rejectionHandled', promise);
	    } else if (handler = _global.onrejectionhandled) {
	      handler({ promise: promise, reason: promise._v });
	    }
	  });
	};
	var $reject = function (value) {
	  var promise = this;
	  if (promise._d) return;
	  promise._d = true;
	  promise = promise._w || promise; // unwrap
	  promise._v = value;
	  promise._s = 2;
	  if (!promise._a) promise._a = promise._c.slice();
	  notify(promise, true);
	};
	var $resolve = function (value) {
	  var promise = this;
	  var then;
	  if (promise._d) return;
	  promise._d = true;
	  promise = promise._w || promise; // unwrap
	  try {
	    if (promise === value) throw TypeError$1("Promise can't be resolved itself");
	    if (then = isThenable(value)) {
	      microtask(function () {
	        var wrapper = { _w: promise, _d: false }; // wrap
	        try {
	          then.call(value, _ctx($resolve, wrapper, 1), _ctx($reject, wrapper, 1));
	        } catch (e) {
	          $reject.call(wrapper, e);
	        }
	      });
	    } else {
	      promise._v = value;
	      promise._s = 1;
	      notify(promise, false);
	    }
	  } catch (e) {
	    $reject.call({ _w: promise, _d: false }, e); // wrap
	  }
	};

	// constructor polyfill
	if (!USE_NATIVE) {
	  // 25.4.3.1 Promise(executor)
	  $Promise = function Promise(executor) {
	    _anInstance(this, $Promise, PROMISE, '_h');
	    _aFunction(executor);
	    Internal.call(this);
	    try {
	      executor(_ctx($resolve, this, 1), _ctx($reject, this, 1));
	    } catch (err) {
	      $reject.call(this, err);
	    }
	  };
	  // eslint-disable-next-line no-unused-vars
	  Internal = function Promise(executor) {
	    this._c = [];             // <- awaiting reactions
	    this._a = undefined;      // <- checked in isUnhandled reactions
	    this._s = 0;              // <- state
	    this._d = false;          // <- done
	    this._v = undefined;      // <- value
	    this._h = 0;              // <- rejection state, 0 - default, 1 - handled, 2 - unhandled
	    this._n = false;          // <- notify
	  };
	  Internal.prototype = _redefineAll($Promise.prototype, {
	    // 25.4.5.3 Promise.prototype.then(onFulfilled, onRejected)
	    then: function then(onFulfilled, onRejected) {
	      var reaction = newPromiseCapability(_speciesConstructor(this, $Promise));
	      reaction.ok = typeof onFulfilled == 'function' ? onFulfilled : true;
	      reaction.fail = typeof onRejected == 'function' && onRejected;
	      reaction.domain = isNode$1 ? process$2.domain : undefined;
	      this._c.push(reaction);
	      if (this._a) this._a.push(reaction);
	      if (this._s) notify(this, false);
	      return reaction.promise;
	    },
	    // 25.4.5.1 Promise.prototype.catch(onRejected)
	    'catch': function (onRejected) {
	      return this.then(undefined, onRejected);
	    }
	  });
	  OwnPromiseCapability = function () {
	    var promise = new Internal();
	    this.promise = promise;
	    this.resolve = _ctx($resolve, promise, 1);
	    this.reject = _ctx($reject, promise, 1);
	  };
	  _newPromiseCapability.f = newPromiseCapability = function (C) {
	    return C === $Promise || C === Wrapper
	      ? new OwnPromiseCapability(C)
	      : newGenericPromiseCapability(C);
	  };
	}

	_export(_export.G + _export.W + _export.F * !USE_NATIVE, { Promise: $Promise });
	_setToStringTag($Promise, PROMISE);
	_setSpecies(PROMISE);
	Wrapper = _core[PROMISE];

	// statics
	_export(_export.S + _export.F * !USE_NATIVE, PROMISE, {
	  // 25.4.4.5 Promise.reject(r)
	  reject: function reject(r) {
	    var capability = newPromiseCapability(this);
	    var $$reject = capability.reject;
	    $$reject(r);
	    return capability.promise;
	  }
	});
	_export(_export.S + _export.F * (_library ), PROMISE, {
	  // 25.4.4.6 Promise.resolve(x)
	  resolve: function resolve(x) {
	    return _promiseResolve( this === Wrapper ? $Promise : this, x);
	  }
	});
	_export(_export.S + _export.F * !(USE_NATIVE && _iterDetect(function (iter) {
	  $Promise.all(iter)['catch'](empty);
	})), PROMISE, {
	  // 25.4.4.1 Promise.all(iterable)
	  all: function all(iterable) {
	    var C = this;
	    var capability = newPromiseCapability(C);
	    var resolve = capability.resolve;
	    var reject = capability.reject;
	    var result = _perform(function () {
	      var values = [];
	      var index = 0;
	      var remaining = 1;
	      _forOf(iterable, false, function (promise) {
	        var $index = index++;
	        var alreadyCalled = false;
	        values.push(undefined);
	        remaining++;
	        C.resolve(promise).then(function (value) {
	          if (alreadyCalled) return;
	          alreadyCalled = true;
	          values[$index] = value;
	          --remaining || resolve(values);
	        }, reject);
	      });
	      --remaining || resolve(values);
	    });
	    if (result.e) reject(result.v);
	    return capability.promise;
	  },
	  // 25.4.4.4 Promise.race(iterable)
	  race: function race(iterable) {
	    var C = this;
	    var capability = newPromiseCapability(C);
	    var reject = capability.reject;
	    var result = _perform(function () {
	      _forOf(iterable, false, function (promise) {
	        C.resolve(promise).then(capability.resolve, reject);
	      });
	    });
	    if (result.e) reject(result.v);
	    return capability.promise;
	  }
	});

	_export(_export.P + _export.R, 'Promise', { 'finally': function (onFinally) {
	  var C = _speciesConstructor(this, _core.Promise || _global.Promise);
	  var isFunction = typeof onFinally == 'function';
	  return this.then(
	    isFunction ? function (x) {
	      return _promiseResolve(C, onFinally()).then(function () { return x; });
	    } : onFinally,
	    isFunction ? function (e) {
	      return _promiseResolve(C, onFinally()).then(function () { throw e; });
	    } : onFinally
	  );
	} });

	// https://github.com/tc39/proposal-promise-try




	_export(_export.S, 'Promise', { 'try': function (callbackfn) {
	  var promiseCapability = _newPromiseCapability.f(this);
	  var result = _perform(callbackfn);
	  (result.e ? promiseCapability.reject : promiseCapability.resolve)(result.v);
	  return promiseCapability.promise;
	} });

	var promise = _core.Promise;

	var promise$1 = promise;

	var $JSON = _core.JSON || (_core.JSON = { stringify: JSON.stringify });
	var stringify = function stringify(it) { // eslint-disable-line no-unused-vars
	  return $JSON.stringify.apply($JSON, arguments);
	};

	var stringify$1 = stringify;

	var f$4 = Object.getOwnPropertySymbols;

	var _objectGops = {
		f: f$4
	};

	var f$5 = {}.propertyIsEnumerable;

	var _objectPie = {
		f: f$5
	};

	// 19.1.2.1 Object.assign(target, source, ...)






	var $assign = Object.assign;

	// should work with symbols and should have deterministic property order (V8 bug)
	var _objectAssign = !$assign || _fails(function () {
	  var A = {};
	  var B = {};
	  // eslint-disable-next-line no-undef
	  var S = Symbol();
	  var K = 'abcdefghijklmnopqrst';
	  A[S] = 7;
	  K.split('').forEach(function (k) { B[k] = k; });
	  return $assign({}, A)[S] != 7 || Object.keys($assign({}, B)).join('') != K;
	}) ? function assign(target, source) { // eslint-disable-line no-unused-vars
	  var T = _toObject(target);
	  var aLen = arguments.length;
	  var index = 1;
	  var getSymbols = _objectGops.f;
	  var isEnum = _objectPie.f;
	  while (aLen > index) {
	    var S = _iobject(arguments[index++]);
	    var keys = getSymbols ? _objectKeys(S).concat(getSymbols(S)) : _objectKeys(S);
	    var length = keys.length;
	    var j = 0;
	    var key;
	    while (length > j) {
	      key = keys[j++];
	      if (!_descriptors || isEnum.call(S, key)) T[key] = S[key];
	    }
	  } return T;
	} : $assign;

	// 19.1.3.1 Object.assign(target, source)


	_export(_export.S + _export.F, 'Object', { assign: _objectAssign });

	var assign = _core.Object.assign;

	var assign$1 = assign;

	// 7.2.2 IsArray(argument)

	var _isArray = Array.isArray || function isArray(arg) {
	  return _cof(arg) == 'Array';
	};

	// 22.1.2.2 / 15.4.3.2 Array.isArray(arg)


	_export(_export.S, 'Array', { isArray: _isArray });

	var isArray = _core.Array.isArray;

	var isArray$1 = isArray;

	/*
	    Google Publisher Tag
	    @1.0.1: - Load GPT from securepubads.g.doubleclick.net
	    ------------------------------------------------------
	    GDPR Status: Blocked
	    CCPA Status: Blocked
	*/
	var MODULE_NAME = 'Google Publisher Tag';
	var MODULE_VERSION = 'v1.0.1';
	var logger;

	var init = function init(config) {
	  var initPromise = new promise$1(function (resolve) {
	    logger = window.AdFuelUtils.getLogger(MODULE_NAME, MODULE_VERSION, 'gpt', 'color: #58f53f; padding: 2px', config && config.ADFUEL ? config.ADFUEL.DEBUG : false);

	    if (!document.getElementById('GPTScript')) {
	      logger.log('Predefining googletag and googletag.cmd...');
	      window.googletag = window.googletag || {};
	      window.googletag.cmd = window.googletag.cmd || [];
	      var gpta = document;
	      var gptb = gpta.createElement('script');
	      var gptc = gpta.getElementsByTagName('script')[0];
	      var gptd = document.location.protocol === 'https:';
	      gptb.id = 'GPTScript';
	      gptb.type = 'text/javascript';
	      gptb.src = (gptd ? 'https:' : 'http:') + '//securepubads.g.doubleclick.net/tag/js/gpt.js';
	      logger.log('Including GPT Library: ', gptb.src);
	      gptc.parentNode.insertBefore(gptb, gptc);
	    }

	    resolve();
	  });
	  initPromise.id = "".concat(MODULE_NAME, " ").concat(MODULE_VERSION);
	  return initPromise;
	};

	var remove = function remove() {
	  var gpta = document;
	  var gptb = gpta.getElementById('GPTScript');
	  var gptc = gpta.getElementsByTagName('script')[0];
	  gptc.parentNode.removeChild(gptb);
	  delete window.googletag;
	};

	var googleTag = {
	  init: init,
	  remove: remove,
	  runAuction: function runAuction() {
	    var auctionPromise = new promise$1(function (resolve) {
	      resolve();
	    });
	    auctionPromise.id = "".concat(MODULE_NAME, " ").concat(MODULE_VERSION);
	    return auctionPromise;
	  },
	  buildSlot: function buildSlot() {
	    var buildPromise = new promise$1(function (resolve) {
	      resolve();
	    });
	    buildPromise.id = "".concat(MODULE_NAME, " ").concat(MODULE_VERSION);
	    return buildPromise;
	  },
	  setTargeting: function setTargeting() {
	    var targetingPromise = new promise$1(function (resolve) {
	      resolve();
	    });
	    targetingPromise.id = "".concat(MODULE_NAME, " ").concat(MODULE_VERSION);
	    return targetingPromise;
	  },
	  __NAME__: MODULE_NAME,
	  __VERSION__: MODULE_VERSION
	};

	var version = "2.1.15";

	if (typeof window !== 'undefined' && typeof document !== 'undefined') {
	  window.googletag = window.googletag || {};
	  window.googletag.cmd = window.googletag.cmd || [];
	} // Define local AdFuel variables


	var NAME$1 = 'AdFuel';
	var VERSION = version;
	var siteOptions = {};
	var initEventSet = false;
	var _options = {};
	window.AdFuelUtils = window.AdFuelUtils || {
	  addEvent: function addEvent() {},
	  bind: function bind() {},
	  cdnRoot: '',
	  clone: function clone() {},
	  countryCode: '',
	  debounce: function debounce() {},
	  gdprApplies: false,
	  getFullConsentState: function getFullConsentState() {},
	  getConsentVersion: function getConsentVersion() {},
	  getConsentString: function getConsentString() {},
	  getConsent: function getConsent() {},
	  getGDPRApplies: function getGDPRApplies() {},
	  getCCPAApplies: function getCCPAApplies() {},
	  getUserConsentRegion: function getUserConsentRegion() {},
	  getLocation: function getLocation() {},
	  generateCacheBuster: function generateCacheBuster() {},
	  getBrowser: function getBrowser() {},
	  getLogger: function getLogger() {
	    return {
	      log: function log() {},
	      warn: function warn() {},
	      error: function error() {},
	      group: function group() {},
	      groupEnd: function groupEnd() {}
	    };
	  },
	  getUMTOCookies: function getUMTOCookies() {},
	  getURLParam: function getURLParam() {},
	  getViewport: function getViewport() {},
	  hasCookie: function hasCookie() {},
	  hasOwn: function hasOwn() {},
	  hasUserConsent: function hasUserConsent() {},
	  isFunction: function isFunction() {},
	  isIntl: false,
	  isMobile: {
	    any: false,
	    phone: false
	  },
	  isMonetized: function isMonetized() {},
	  isObject: function isObject() {},
	  keyMap: function keyMap() {},
	  merge: function merge() {},
	  mergeDeep: function mergeDeep() {},
	  noop: function noop() {},
	  once: function once() {},
	  performance: {
	    adfuelEntries: [],
	    getTrackPerformance: function getTrackPerformance() {},
	    mark: function mark() {},
	    measure: function measure() {},
	    marks: function marks() {},
	    measures: function measures() {},
	    queueEntry: function queueEntry() {}
	  },
	  piiFilter: {
	    hash: false,
	    qs: false,
	    ref: false
	  },
	  readCookie: function readCookie() {},
	  roundFloat: function roundFloat() {},
	  selectedEdition: '',
	  setHostAndPathNames: function setHostAndPathNames() {},
	  setIsIntl: function setIsIntl() {},
	  __VERSION__: ''
	};
	var perf = window.AdFuelUtils.performance || {};
	var _initialized = false;
	var _blocked = null;
	var renderStaticAds = false;
	var _pageSlots = {};
	var _rocketeerSlots = [];
	var _builtSlots = [];
	var _queuedSlots = [];
	var _dispatchedSlots = [];

	var _adsQAPageLevelKey;

	var _adsQAPageLevelValue;

	var _setChildDirectedTreatment;

	var _setSafeFrameConfig;

	var _dynamicTargeting = {
	  pageTargets: {},
	  slotTargets: {}
	};
	var _pageLevelTargeting = [];

	var _inheritableAdUnit;

	var _preQueueExecuting = false;
	var _delayingDispatch = false; // contains queueRegistry functions which must be delayed until registries are queueable

	var _delayedRegistryQueues = []; // contains dispatchQueue functions which must be delayed until queues are dispatchable

	var _delayedDispatchQueues = []; // contains dispatchQueue functions which must be delayed until users request their dispatch

	var _userDispatchedQueues = []; // contains registered Modules (name, callbacks)

	var _registeredModules = []; // contains slot ids which can be excluded via _options.exclude or queueRegistery queueOptions.exclude
	// excluded slots must be explicitly dispatched via dispatchOptions.slots

	var _excludedSlotIds = []; // contains the registry data from queued registries to be used in the event of a re-queue
	// of the same registry

	var _cachedRegistries = {}; // create instance of logger for AdFuel

	var logger$1 = window.AdFuelUtils.getLogger(NAME$1, VERSION, 'adfuel', 'color: #4f86f7; padding: 2px', window.AdFuelOptions && window.AdFuelOptions.ADFUEL && window.AdFuelOptions.ADFUEL.DEBUG || false);
	var UserConsentLogger = window.AdFuelUtils.getLogger(' User Consent', '', 'consent', 'color: coral; padding: 2px', siteOptions && siteOptions.USER_CONSENT && siteOptions.USER_CONSENT.DEBUG || false);

	function _isRegistryQueueable() {
	  var userConsentEnabled = window.AdFuelOptions && window.AdFuelOptions.USER_CONSENT && window.AdFuelOptions.USER_CONSENT.ENABLED === true;
	  var userConsentReady = window.WM && window.WM.UserConsent ? window.WM.UserConsent.isReady() : false;
	  var consentToQueue = true;

	  if (userConsentEnabled) {
	    if (userConsentReady) {
	      var consentRegion = window.WM.UserConsent.getRegion();

	      if (consentRegion === 'gdpr') {
	        if (window.WM.UserConsent.isOptanonLoaded()) {
	          var consentStatus = window.WM.UserConsent.getUserConsentAdvertisingState();
	          logger$1.log('Region is GDPR and Optanon is ready. Setting consentToQueue:', consentStatus);
	          consentToQueue = consentStatus;
	        } else {
	          logger$1.log('Region is GDPR but Optanon is not ready. Setting consentToQueue:', false);
	          consentToQueue = false;
	        }
	      } else {
	        logger$1.log('Region is not GDPR.');
	      }
	    } else {
	      logger$1.log('UserConsent is not ready. Setting consentToQueue:', false);
	      consentToQueue = false;
	    }
	  }

	  if (consentToQueue && (!_initialized || _registeredModules.length === 0)) {
	    logger$1.log('AdFuel is not ready or modules not registered. Revoking consentToQueue.', {
	      init: _initialized,
	      mods: _registeredModules.length
	    });
	    consentToQueue = false;
	  }

	  logger$1.log('Is registry queueable:', consentToQueue);
	  return consentToQueue;
	}

	function _queueDelayedRegistries() {
	  if (_isRegistryQueueable()) {
	    logger$1.log('Initializing GoogleTag Library...');
	    googleTag.init(siteOptions);

	    if (_delayedRegistryQueues.length > 0) {
	      logger$1.log('Executing delayed registry queues...');

	      _delayedRegistryQueues.forEach(function (delayedQueue) {
	        delayedQueue();
	      });

	      logger$1.log('Clearing delayed registry queue...');
	      _delayedRegistryQueues.length = 0;
	    }
	  } else {
	    logger$1.log('Registries are still not queueable. Waiting 250ms...');
	    var userConsentEnabled = window.AdFuelOptions && window.AdFuelOptions.USER_CONSENT && window.AdFuelOptions.USER_CONSENT.ENABLED === true;
	    var userConsentReady = window.WM && window.WM.UserConsent ? window.WM.UserConsent.isReady() : false;
	    var userConsentRegion = window.WM && window.WM.UserConsent ? window.WM.UserConsent.getRegion() : 'global';
	    var userConsentStatus = window.WM && window.WM.UserConsent ? window.WM.UserConsent.getUserConsentAdvertisingState() : !userConsentEnabled;

	    if (!userConsentEnabled || !userConsentReady || userConsentRegion !== 'gdpr' || userConsentRegion === 'gdpr' && userConsentStatus === true) {
	      setTimeout(_queueDelayedRegistries, 250);
	    }
	  }
	} // main AdFuel registry handler


	var RegistryArray = function RegistryArrayFunc() {
	  var self = [];

	  self.push = function pushFunc(asset, options) {
	    if (!isArray$1(asset)) {
	      return;
	    }

	    if (_isRegistryQueueable()) {
	      perf.mark('Queue Registry [' + asset[0].rktr_id + '] Start'); // Always work with a clone of the supplied arguments to conform to the FP paradigm.

	      var assetClone = asset;
	      var optionsClone = options ? assign$1({}, options) : {
	        dispatch: true
	      };
	      optionsClone.dispatch = optionsClone.dispatch || _options.autoDispatch;
	      logger$1.log('Asset Clone: ', assetClone); // Begin Queueing of Registry
	      // Calls preQueueCallback and postQueueCallback
	      // Dispatches queue if _options.autoDispatch

	      _preQueueExecuting = true;
	      var assetIndex; // Filter out slots not present in the 'slots' option or present in the 'exclude' option if supplied.
	      // Also check _excludedSlotIds for any slot that may have been previously excluded.

	      assetClone = assetClone.filter(function (slot, index) {
	        if (index === 0) return true; // This first check is necessary in order to dispatch excluded slots when specifically called to do so.

	        if (optionsClone.slots && optionsClone.slots.length > 0 && optionsClone.slots.indexOf(slot.rktr_slot_id) !== -1) {
	          // Remove the slot from excluded slots since it's being specificially called for dispatch.
	          if (_excludedSlotIds.indexOf(slot.rktr_slot_id) !== -1) {
	            _excludedSlotIds.splice(_excludedSlotIds.indexOf(slot.rktr_slot_id), 1);
	          }

	          return true;
	        }

	        if (optionsClone.slots && optionsClone.slots.length > 0 && optionsClone.slots.indexOf(slot.rktr_slot_id) === -1) {
	          logger$1.log('Slot [' + slot.rktr_slot_id + '] is being excluded based on slot options.');
	          return false;
	        }

	        if (optionsClone.exclude && optionsClone.exclude.length > 0 && optionsClone.exclude.indexOf(slot.rktr_slot_id) !== -1) {
	          logger$1.log('Slot [' + slot.rktr_slot_id + '] is being excluded based on exclude options.');
	          return false;
	        }

	        if (_excludedSlotIds.length > 0 && _excludedSlotIds.indexOf(slot.rktr_slot_id) !== -1) {
	          logger$1.log('Slot [' + slot.rktr_slot_id + '] is being excluded based on previously excluded slots.');
	          return false;
	        }

	        return true;
	      }); // Modify the asset to correlate to the slot map, if passed.

	      if (optionsClone.slotMap) {
	        logger$1.log('Parsing Slot Map: ', optionsClone.slotMap, assetClone);

	        for (assetIndex = 1; assetIndex < assetClone.length; assetIndex++) {
	          logger$1.log('Checking Slot: ', assetClone[assetIndex].rktr_slot_id);

	          if (optionsClone.slotMap[assetClone[assetIndex].rktr_slot_id]) {
	            logger$1.log('Overriding Element Id for: ' + assetClone[assetIndex].rktr_slot_id, optionsClone.slotMap[assetClone[assetIndex].rktr_slot_id]);
	            assetClone[assetIndex].rktr_slot_id = optionsClone.slotMap[assetClone[assetIndex].rktr_slot_id];
	          }
	        }
	      } // Modify the asset to correlate to the ad unit map, if passed.


	      if (optionsClone && optionsClone.adUnitMap) {
	        logger$1.log('Parsing Ad Unit Map: ', optionsClone.adUnitMap, assetClone);

	        if (typeof optionsClone.adUnitMap === 'string') {
	          logger$1.log('Overriding All Ad Units: ', optionsClone.adUnitMap);

	          for (assetIndex = 1; assetIndex < assetClone.length; assetIndex++) {
	            assetClone[assetIndex].rktr_ad_id = optionsClone.adUnitMap;
	          }
	        } else {
	          for (assetIndex = 1; assetIndex < assetClone.length; assetIndex++) {
	            logger$1.log('Checking Slot: ', assetClone[assetIndex].rktr_slot_id);

	            if (optionsClone.adUnitMap[assetClone[assetIndex].rktr_slot_id]) {
	              logger$1.log('Overriding Ad Unit for: ' + assetClone[assetIndex].rktr_slot_id, optionsClone.adUnitMap[assetClone[assetIndex].rktr_slot_id]);
	              assetClone[assetIndex].rktr_ad_id = optionsClone.adUnitMap[assetClone[assetIndex].rktr_slot_id];
	            }
	          }
	        }
	      }

	      var monetizedAssets = [];
	      assetClone.forEach(function (clonedAsset) {
	        var monetization = window.AdFuelUtils.isMonetized(clonedAsset);

	        if (asset.rktr_slot_id !== 'page' && monetization.isMonetized) {
	          clonedAsset.monetization = monetization;
	          monetizedAssets.push(clonedAsset);
	        }
	      });
	      logger$1.log('Monetized Slots: ', monetizedAssets); // Add asset to this array

	      Array.prototype.push.call(self, assetClone);
	      var slotsToDisplay = assetClone.filter(function (slot) {
	        var test1 = !optionsClone.slots || optionsClone.slots.length === 0 || optionsClone.slots.indexOf(slot.rktr_slot_id) >= 0;
	        var test2 = !optionsClone.exclude || _excludedSlotIds.length === 0 || _excludedSlotIds.indexOf(slot.rktr_slot_id) < 0;
	        var test3 = optionsClone.slots && optionsClone.slots.length > 0 || _excludedSlotIds.indexOf(slot.rktr_slot_id) < 0;
	        var validSlot = test1 && test2 && test3;
	        return validSlot;
	      });
	      logger$1.log('slots To display: ', slotsToDisplay);

	      var queueingProcedure = function _queueingProcedure() {
	        var registryName = assetClone[0].rktr_id;
	        logger$1.log('Queueing Procedure for: ', assetClone); // set child directed treatment flag

	        if (typeof assetClone[0].child_directed_treatment !== 'undefined') {
	          _setChildDirectedTreatment = assetClone[0].child_directed_treatment === 'true' ? 1 : 0;
	        } // set SafeFrame config


	        if (typeof assetClone[0].safeframe_config !== 'undefined') {
	          _setSafeFrameConfig = assetClone[0].safeframe_config;
	        }

	        if (!assetClone[0].singleton) {
	          // registry, non-singleton
	          // save page level targeting
	          _applyRegistryPageLevelTargeting(assetClone[0].targeting); // set inheritable adunit based on first slot


	          try {
	            _inheritableAdUnit = _removeLeadingNumericNetworkId(assetClone[1].rktr_ad_id);
	          } catch (e) {
	            logger$1.log('Could not find inheritable Ad Unit.', assetClone);
	          }
	        }

	        var pageLevelRoot = _options.siteObject || (assetClone[0].root ? assetClone[0].root.toUpperCase() : assetClone[0].site.toUpperCase());
	        logger$1.log('Page Level Root: ', pageLevelRoot);
	        logger$1.log('Grabbing targeting from window object:', window[pageLevelRoot] ? window[pageLevelRoot].adTargets : {}, window[pageLevelRoot] ? window[pageLevelRoot].slotTargets : {});

	        _applyWindowSiteLevelOptions(pageLevelRoot); // process slots


	        var startListeners = false;

	        for (var x = 1; x < assetClone.length; x++) {
	          var slot = asset[x];
	          slot.parentRegistry = registryName;

	          if (!slot.queued) {
	            var hasInViewRefresh = assetClone[0].hasInViewRefresh ? assetClone[0].hasInViewRefresh : slot.hasInViewRefresh;

	            if (hasInViewRefresh === true) {
	              startListeners = true;
	            }

	            logger$1.log('Adding slot to slots registry: ', slot, JSON.parse(stringify$1(_rocketeerSlots)));

	            _rocketeerSlots.push(slot);
	          }
	        }

	        if (startListeners && typeof window._startInViewListeners !== 'undefined') {
	          window._startInViewListeners();
	        }
	      };

	      getFilterValue().then(function (blocked) {
	        logger$1.log('Should render static ads? ', blocked); // renderStaticAds = blocked

	        if (window.AdFuelUtils.getURLParam('renderStatic') !== '') {
	          logger$1.log('Using query string override for static ad rendering...');
	          renderStaticAds = window.AdFuelUtils.getURLParam('renderStatic');
	        }

	        if (renderStaticAds !== false && renderStaticAds !== '' && typeof renderStaticAds !== 'undefined') {
	          renderStaticAd(assetClone);
	        } else {
	          logger$1.log('Executing pre-queue callbacks...', {
	            monetized: monetizedAssets,
	            registry: asset
	          });
	          var monetizedAndBuilt = [];

	          _buildSlots(assetClone, options).then(function (builtSlots) {
	            logger$1.log('Monetized slots: ', monetizedAssets);
	            logger$1.log('Built slots: ', builtSlots);
	            monetizedAndBuilt = monetizedAssets.filter(function (monAsset) {
	              var isBuilt = false;
	              builtSlots.forEach(function (bldAsset) {
	                if (monAsset.rktr_slot_id === bldAsset.rktr_slot_id) isBuilt = true;
	              });
	              logger$1.log("Is ".concat(monAsset.rktr_slot_id, " built? ").concat(isBuilt ? 'YES' : 'NO'));
	              return isBuilt;
	            });
	            logger$1.log('Monetized and Built: ', monetizedAndBuilt);
	            executeModuleCallbacks('preQueueCallback', monetizedAndBuilt, assetClone, optionsClone).then(function () {
	              _preQueueExecuting = false;
	              logger$1.log('Pre-Queue Processes Complete!');

	              try {
	                var PreQueueCompleteEvent = new CustomEvent('PreQueueComplete', {
	                  detail: {
	                    asset: asset
	                  }
	                });
	                document.dispatchEvent(PreQueueCompleteEvent);
	              } catch (ex) {
	                logger$1.error('error dispatching custom Event: PreQueueComplete', {
	                  error: ex
	                });
	              }

	              logger$1.log('Pre-Queue Complete!');
	              logger$1.log('Executing Queueing Procedures...');
	              queueingProcedure();
	              perf.mark('Queue Registry [' + asset[0].rktr_id + '] End');
	              perf.measure('Queue Registry [' + asset[0].rktr_id + ']', 'Queue Registry [' + asset[0].rktr_id + '] Start', 'Queue Registry [' + asset[0].rktr_id + '] End');

	              if (optionsClone.dispatch) {
	                logger$1.log('Dispatching Queue...');
	                dispatchQueue(optionsClone);
	              }

	              if (_delayingDispatch) {
	                _delayingDispatch = false;

	                _dispatchAllQueues();
	              }
	            });
	          });
	        }
	      });
	    } else {
	      _delayedRegistryQueues.push(function () {
	        window.AdFuel.registry.push(asset, options);
	      });
	    }
	  };

	  return self;
	}; // execute module callbacks


	var executeModuleCallbacks = function _executeModuleCallbacks(eventName, monetized, slots, options) {
	  var moduleCallbackPromise = new promise$1(function (resolve) {
	    var moduleCallbacks = _registeredModules.filter(function (module) {
	      logger$1.log("".concat(module.name, " has ").concat(eventName, "?  ").concat(!!module.callbacks[eventName]));
	      return !!module.callbacks[eventName];
	    }).map(function (module) {
	      var isMonetized = module.monetized;
	      logger$1.log("Calling ".concat(module.name, " ").concat(eventName, " callback with ").concat(isMonetized ? 'monetized' : 'all', " slots."));
	      return module.callbacks[eventName](isMonetized ? monetized : slots);
	    });

	    if (options && options[eventName]) {
	      // add optional preRefreshCallback
	      logger$1.log("Calling user-defined ".concat(eventName, " callback with all slots."));
	      moduleCallbacks.push(options[eventName](slots));
	    }

	    logger$1.log("".concat(eventName, " Callbacks:"), moduleCallbacks);

	    if (moduleCallbacks.length > 0) {
	      promise$1.all(moduleCallbacks).then(function (results) {
	        resolve(results);
	      });
	    } else {
	      resolve();
	    }
	  });
	  return moduleCallbackPromise;
	}; // bind a function to DOMContentLoaded


	function _bindReady(callback) {
	  var domContentLoadedCalled = false;
	  var windowLoadCalled = false;
	  var called = false;

	  function ready(eventName) {
	    // ensure this only executes once for each event
	    if (eventName === 'DOMContentLoaded' && !domContentLoadedCalled) {
	      perf.mark('AdFuel DOMContentLoaded');

	      if (_options.autoDispatch) {
	        logger$1.log('DOM Content has loaded. Auto-Dispatching Queue...');

	        _dispatchAllQueues();
	      }

	      domContentLoadedCalled = true;
	      called = true;
	      if (callback && typeof callback === 'function') callback();
	    }

	    if (eventName === 'window.load' && !windowLoadCalled) {
	      perf.mark('AdFuel window.load');

	      if (_options.autoDispatch) {
	        logger$1.log('Window has loaded. Auto-Dispatching Queue...');

	        _dispatchAllQueues();
	      }

	      windowLoadCalled = true;
	      called = true;
	      if (callback && typeof callback === 'function') callback();
	    }
	  }

	  function tryScroll() {
	    if (!called) {
	      try {
	        document.documentElement.doScroll('left');
	        ready('DOMContentLoaded');
	      } catch (e) {
	        setTimeout(tryScroll, 10);
	      }
	    }
	  } // listen for document DOMContentLoaded/complete/loaded/interactive


	  if (document.addEventListener) {
	    window.AdFuelUtils.addEvent(document, 'DOMContentLoaded', function () {
	      ready('DOMContentLoaded');
	    });
	  } else if (document.attachEvent) {
	    // IE
	    var isFrame = false;

	    try {
	      isFrame = window.frameElement !== null;
	    } catch (e) {} // Do Nothing
	    // IE, the document is not inside a frame


	    if (document.documentElement.doScroll && !isFrame) {
	      tryScroll();
	    } // IE, the document is inside a frame


	    window.AdFuelUtils.addEvent(document, 'readystatechange', function () {
	      if (document.readyState === 'complete' || document.readyState === 'loaded' || document.readyState === 'interactive') {
	        ready('DOMContentLoaded');
	      }
	    });
	  } // listen for window load/onload


	  if (window.addEventListener || window.attachEvent) {
	    window.AdFuelUtils.addEvent(window, 'load', function () {
	      ready('window.load');
	    });
	  } else {
	    var fn = window.onload; // very old browser, copy old onload

	    window.onload = function () {
	      // replace by new onload and call the old one
	      fn && fn();
	      ready('window.load');
	    };
	  } // Fallback if adfuel is put on page post-DOMContentLoaded


	  if (document.readyState === 'complete' || document.readyState === 'loaded' || document.readyState === 'interactive') {
	    ready('DOMContentLoaded');
	  }
	} // occurs once upon init parsing url for adsQA page-level targeting


	function _checkForAdsQA() {
	  try {
	    var qaparam = window.AdFuelUtils.getURLParam('adsqa');

	    if (qaparam) {
	      var qaparamPieces = qaparam.split('%3D');
	      _adsQAPageLevelKey = qaparamPieces[0];
	      _adsQAPageLevelValue = qaparamPieces[1];
	      _dynamicTargeting.pageTargets[_adsQAPageLevelKey] = _adsQAPageLevelValue;
	    }
	  } catch (err) {
	    logger$1.error('checkForAdsQA', err);
	  }
	} // this will be called each time a singleton/registry is queued
	// no need to call addPageLevelTarget/addSlotLevelTarget, because GPT Page may or may not have been built


	function _applyRegistryPageLevelTargeting(targeting) {
	  perf.mark('Applying Page-Level Targeting');

	  for (var tIndex = 0; tIndex < targeting.length; tIndex++) {
	    var target = targeting[tIndex];
	    var currentTargeting = _dynamicTargeting.pageTargets[target[0]] || [];

	    for (var valIndex = 0; valIndex < target[1].length; valIndex++) {
	      var value = target[1][valIndex];

	      if (currentTargeting.indexOf(value) < 0) {
	        currentTargeting.push(value);
	      }
	    }

	    _dynamicTargeting.pageTargets[target[0]] = currentTargeting;
	  }
	} // this will be called each time a singleton/registry is queued
	// no need to call addPageLevelTarget/addSlotLevelTarget, because GPT Page has not been built


	function _applyWindowSiteLevelOptions(siteLvl) {
	  if (window[siteLvl]) {
	    // moved to setOptions
	    // if (window[siteLvl].refreshOnFocusOnly){
	    //    _options.refreshOnFocusOnly = true;
	    // }
	    perf.mark('Applying Window Site-Level Options.');

	    if (window[siteLvl].adTargets) {
	      keys$1(window[siteLvl].adTargets).forEach(function (key) {
	        _dynamicTargeting.pageTargets[key] = window[siteLvl].adTargets[key];
	      });
	    }

	    if (window[siteLvl].slotTargets) {
	      keys$1(window[siteLvl].slotTargets).forEach(function (slotId) {
	        var slotTargeting = window[siteLvl].slotTargets[slotId];

	        if (!_dynamicTargeting.slotTargets[slotId]) {
	          _dynamicTargeting.slotTargets[slotId] = {};
	        }

	        keys$1(slotTargeting).forEach(function (key2) {
	          _dynamicTargeting.slotTargets[slotId][key2] = slotTargeting[key2];
	        });
	      });
	    }
	  }
	} // this will return targeting set in the registry, by the page, and by calls to AdFuel


	function _getCombinedSlotTargeting(rocketeerSlot) {
	  var slotTargeting = assign$1({}, rocketeerSlot.targeting);

	  if (!isArray$1(slotTargeting)) {
	    slotTargeting = [slotTargeting];
	  }

	  var dynamicSlotTargeting = _dynamicTargeting.slotTargets;

	  if (dynamicSlotTargeting[rocketeerSlot.rktr_slot_id]) {
	    keys$1(dynamicSlotTargeting[rocketeerSlot.rktr_slot_id]).forEach(function (targetId) {
	      slotTargeting.push([targetId, dynamicSlotTargeting[rocketeerSlot.rktr_slot_id][targetId]]);
	    });
	  }

	  return slotTargeting;
	} // add adfuel-rendered class to container element when ad is rendered


	function _setSlotRenderedClass() {
	  window.AdFuelUtils.addEvent(document, 'GPTRenderComplete', function (e) {
	    var el = document.getElementById(e.detail.divId);

	    if (el && el.className.indexOf('adfuel-rendered') < 0) {
	      el.className += ' adfuel-rendered';
	    }
	  });
	} // removes adfuel-rendered class from supplied slots


	function _removeSlotRenderedClass(slots) {
	  var slotsClone = assign$1({}, slots);

	  if (slotsClone) {
	    if (!isArray$1(slotsClone)) {
	      slotsClone = [slotsClone];
	    }

	    if (slotsClone.length === 0) {
	      slotsClone = getOwnPropertyNames$1(_pageSlots);
	    }
	  }

	  for (var x = 0; x < slotsClone.length; x++) {
	    var slotId = slotsClone[x];
	    var el = document.getElementById(slotId);

	    if (el && el.className.indexOf('adfuel-rendered') > 0) {
	      el.className = el.className.replace('adfuel-rendered', '');
	    }
	  }
	}

	function _removePageSlots(slots) {
	  var slotsClone = assign$1({}, slots);

	  if (slotsClone) {
	    if (!isArray$1(slotsClone)) {
	      slotsClone = [slotsClone];
	    }

	    if (slotsClone.length === 0) {
	      slotsClone = getOwnPropertyNames$1(_pageSlots);
	    }
	  }

	  for (var x = 0; x < slotsClone.length; x++) {
	    var slotId = slotsClone[x];

	    if (_pageSlots[slotId]) {
	      delete _pageSlots[slotId];
	    }
	  }
	}

	function _removeRocketeerSlots(slots) {
	  var slotsClone = assign$1({}, slots);

	  if (slotsClone) {
	    if (!isArray$1(slotsClone)) {
	      slotsClone = [slots];
	    }

	    if (slotsClone.length === 0) {
	      slotsClone = getOwnPropertyNames$1(_pageSlots);
	    }
	  }

	  logger$1.log('Removing Rocketeer Slots: ', slotsClone);

	  for (var x = 0; x < _rocketeerSlots.length; x++) {
	    var slotId = _rocketeerSlots[x].rktr_slot_id;

	    if (slotsClone.indexOf(slotId) >= 0 || slotsClone.length === 0) {
	      _rocketeerSlots.splice(x, 1);
	    }
	  }
	}

	function _setAdIFrameTitle() {
	  window.googletag.setAdIframeTitle(_options.iframeTitle);
	}

	function addPageLevelTarget(key, value) {
	  if (!key || !value) {
	    return;
	  }

	  var val = value;
	  var currentTargeting = AdFuel.dynamicTargeting.pageTargets[key] || [];

	  if (!isArray$1(currentTargeting)) {
	    currentTargeting = [currentTargeting];
	  }

	  if (!isArray$1(val)) {
	    val = [val];
	  }

	  for (var vIndex = 0; vIndex < val.length; vIndex++) {
	    if (currentTargeting.indexOf(val[vIndex]) < 0) {
	      currentTargeting.push(val[vIndex]);
	    }
	  }

	  _dynamicTargeting.pageTargets[key] = currentTargeting.filter(function (x, i) {
	    return currentTargeting.indexOf(x) === i;
	  }); // logger.log('Setting Page-Level Targeting', key, currentTargeting);

	  _googleApi.executeWhenAvailable('adding page-level targeting', function () {
	    var data = {};
	    data[key] = AdFuel.dynamicTargeting.pageTargets[key];

	    _googleApi.setTargeting(key, AdFuel.dynamicTargeting.pageTargets[key]);
	  });
	}

	function removePageLevelTarget(key, value) {
	  _googleApi.executeWhenAvailable('removing page-level targeting', function () {
	    var targets = _dynamicTargeting.pageTargets[key] || [];

	    if (typeof value !== 'undefined') {
	      if (targets.indexOf(value) >= 0) {
	        targets.splice(targets.indexOf(value), 1);
	      }

	      _dynamicTargeting.pageTargets[key] = targets;
	    }

	    if (typeof key !== 'undefined' && typeof value === 'undefined') {
	      _googleApi.clearTargeting(key);

	      delete _dynamicTargeting.pageTargets[key];
	      if (targets) targets.length = 0;
	    } else if (typeof key === 'undefined') {
	      _googleApi.clearTargeting();

	      _dynamicTargeting.pageTargets = {};
	    }

	    if (typeof key !== 'undefined' && targets.length === 0) {
	      delete _dynamicTargeting.pageTargets[key];
	    } else if (typeof key !== 'undefined' && targets.length > 0) {
	      _dynamicTargeting.pageTargets[key] = targets;

	      _googleApi.setTargeting(key, targets);
	    } else {
	      _dynamicTargeting.pageTargets = {};

	      if (_adsQAPageLevelKey) {
	        // restore adsQA target
	        _dynamicTargeting.pageTargets[_adsQAPageLevelKey] = _adsQAPageLevelValue;
	        addPageLevelTarget(_adsQAPageLevelKey, _adsQAPageLevelValue);
	      }
	    }
	  });
	}

	function addSlotLevelTarget(slotId, key, value) {
	  var slotTargeting = _dynamicTargeting.slotTargets[slotId] || {};
	  var currentTargeting = slotTargeting[key] || [];

	  if (!isArray$1(currentTargeting)) {
	    currentTargeting = currentTargeting ? [currentTargeting] : [];
	  }

	  if (isArray$1(value)) {
	    for (var vIndex = 0; vIndex < value.length; vIndex++) {
	      currentTargeting.push(value[vIndex]);
	    }
	  } else {
	    currentTargeting.push(value);
	  }

	  _dynamicTargeting.slotTargets[slotId] = _dynamicTargeting.slotTargets[slotId] || {};
	  _dynamicTargeting.slotTargets[slotId][key] = currentTargeting.filter(function (x, i) {
	    return currentTargeting.indexOf(x) === i;
	  });

	  _googleApi.executeWhenAvailable('adding slot-level targeting', function () {
	    var slot = _pageSlots[slotId];

	    if (slot) {
	      // found slot
	      _googleApi.setSlotTargeting(slot, key, currentTargeting);
	    }
	  });
	}

	function removeSlotLevelTarget(slotId, key, value) {
	  _googleApi.executeWhenAvailable('removing slot-level targeting', function () {
	    var slot = _pageSlots[slotId];

	    if (slot) {
	      // valid slot
	      var slotTargeting = {}; // get existing targeting keys

	      var currentTargetingKeys = slot.getTargetingKeys();

	      keys$1(currentTargetingKeys).forEach(function (keyId) {
	        var keyName = currentTargetingKeys[keyId];

	        if (typeof keyName !== 'function') {
	          slotTargeting[keyName] = slot.getTargeting(keyName) || '';
	        }
	      });

	      var defaultSlotTargeting = {
	        pos: slotTargeting.pos
	      };

	      if (key) {
	        // remove only key
	        if (!value) {
	          delete _dynamicTargeting.slotTargets[slotId][key];
	          delete slotTargeting[key];
	        } else {
	          slotTargeting[key].splice(slotTargeting[key].indexOf(value), 1);

	          _dynamicTargeting.slotTargets[slotId][key].splice(_dynamicTargeting.slotTargets[slotId][key].indexOf(value), 1);
	        }
	      } else {
	        // remove everything but pos
	        slotTargeting = {
	          pos: slotTargeting.pos
	        };
	        _dynamicTargeting.slotTargets[slotId].length = 0;
	        _dynamicTargeting.slotTargets[slotId] = defaultSlotTargeting;
	      }

	      _googleApi.clearSlotTargeting(slot); // add back everything in slotTargeting


	      keys$1(slotTargeting).forEach(function (targetKey) {
	        if (slotTargeting[targetKey].length === 0) {
	          slotTargeting[targetKey][0] = '';
	        }

	        _googleApi.setSlotTargeting(slot, targetKey, slotTargeting[targetKey]);
	      });
	    }
	  });
	}

	function _buildPageLevelGPTObject() {
	  perf.mark('Page-Level GPT Build Start');
	  var latlong = window.AdFuelUtils.readCookie('gptgeo');

	  if (!latlong) {
	    logger$1.log('Unable to retrieve location cookie', latlong);
	  } else {
	    // send lat/long to GPT
	    var latlongPieces = latlong.split('%2C');

	    var latitude = _parseFloat$2(latlongPieces[0]);

	    var longitude = _parseFloat$2(latlongPieces[1]);

	    _googleApi.executeWhenAvailable('setting location', function () {
	      _googleApi.setLocation(latitude, longitude);
	    });
	  }

	  if (typeof _setChildDirectedTreatment !== 'undefined') {
	    logger$1.log('Setting Child Directed Treat Tag : ', _setChildDirectedTreatment);

	    _googleApi.executeWhenAvailable('setting child_directed_treatment tag', function () {
	      _googleApi.setChildDirectedTreatmentTag(_setChildDirectedTreatment);
	    });
	  }

	  if (typeof _setSafeFrameConfig !== 'undefined') {
	    logger$1.log('Setting SafeFrame Config Tag : ', _setSafeFrameConfig);

	    _googleApi.executeWhenAvailable('setting safeframe_config', function () {
	      _googleApi.setSafeFrameConfig(_setSafeFrameConfig);
	    });
	  } // combine page level targeting and _dynamicTargeting.pageTargets


	  var targetings = _pageLevelTargeting;
	  var dynamicPageTargeting = _dynamicTargeting.pageTargets;

	  keys$1(dynamicPageTargeting).forEach(function (targetId) {
	    targetings.push([targetId, dynamicPageTargeting[targetId]]);
	  });

	  for (var targetIndex = 0; targetIndex < targetings.length; targetIndex++) {
	    var targetValue = targetings[targetIndex][1]; // convert targetValue to array if necessary

	    if (targetValue && !isArray$1(targetValue)) {
	      if (targetValue.indexOf(',') >= 0) {
	        targetValue = targetValue.split(',');
	      } else {
	        targetValue = [targetValue];
	      }
	    }

	    if (targetings[targetIndex][0] === 'exclusions') {
	      for (var i = 0; i < targetValue.length; i++) {
	        var targetKeyValue = targetings[targetIndex][1][i];

	        _googleApi.executeWhenAvailable('setting category exclusion', function _setCategoryExclusions() {
	          _googleApi.setCategoryExclusion(targetKeyValue);
	        });
	      }
	    } else {
	      var targetKey = targetings[targetIndex][0];
	      addPageLevelTarget(targetKey, targetValue);
	    }
	  }

	  logger$1.log('Setting Page-Level Targeting', targetings);
	  perf.mark('Page-Level GPT Build End');
	  perf.measure('Page-Level GPT Build', 'Page-Level GPT Build Start', 'Page-Level GPT Build End');
	}

	function _applySiteSlotTargeting(slot) {
	  var targetings = slot.targeting;
	  var dynamicSlotTargeting = _dynamicTargeting.slotTargets[slot.rktr_slot_id] || {};
	  var targetKey;

	  if (dynamicSlotTargeting[slot.rktr_slot_id]) {
	    keys$1(dynamicSlotTargeting[slot.rktr_slot_id]).forEach(function (targetKey) {
	      targetings.push([targetKey, dynamicSlotTargeting[slot.rktr_slot_id][targetKey]]);
	    });
	  }

	  if (window[_options.siteObject]) {
	    if (typeof window[_options.siteObject].slotTargets !== 'undefined' && typeof window[_options.siteObject].slotTargets[slot.rktr_slot_id] !== 'undefined') {
	      for (targetKey in window[_options.siteObject].slotTargets[slot.rktr_slot_id]) {
	        targetings.push([targetKey, window[_options.siteObject].slotTargets[slot.rktr_slot_id][targetKey]]);
	      }
	    }
	  }

	  logger$1.log('Setting Slot-Level Targeting', slot.rktr_slot_id, targetings);

	  for (var targetIndex = 0; targetIndex < targetings.length; targetIndex++) {
	    var targetValue = targetings[targetIndex][1]; // convert targetValue to array if necessary

	    if (targetValue && !isArray$1(targetValue)) {
	      if (targetValue.indexOf(',') >= 0) {
	        targetValue = targetValue.split(',');
	      } else {
	        targetValue = [targetValue];
	      }
	    }

	    logger$1.log('Setting Slot Level Target: ', slot.rktr_slot_id, targetKey, targetValue);
	    targetKey = targetings[targetIndex][0];
	    addSlotLevelTarget(slot.rktr_slot_id, targetKey, targetValue);
	  }
	}

	function _renderCheck(rocketeerSlot) {
	  var unrenderedSlots = document.querySelectorAll('div#' + rocketeerSlot.rktr_slot_id);

	  if (unrenderedSlots.length !== 0) {
	    for (var sI = 0; sI < unrenderedSlots.length; sI++) {
	      var slotDiv = unrenderedSlots[sI];

	      if (slotDiv.className.indexOf('adfuel-rendered') >= 0) {
	        /* Element already has an ad rendered in it. */
	        logger$1.log('Found rendered slot...', rocketeerSlot.rktr_slot_id);
	      } else {
	        /* Clean element ready for rendering */
	        if (unrenderedSlots.length === 1 && _pageSlots[rocketeerSlot.rktr_slot_id]) {
	          /*
	            If there is only one element in unrenderedSlots and a GPT Slot object
	            already exists for this id, ignore the element count when updating the
	            slot and clear the slot.
	          */
	          var updatedSlot = _updateSlot(rocketeerSlot, true); // clear the slot before rendering an ad


	          clearSlots(updatedSlot.rktr_slot_id);
	          return updatedSlot;
	        }

	        return _updateSlot(rocketeerSlot);
	      }
	    }
	  } // slot not found


	  logger$1.log("Not building slot... Can't Find Unrendered Slot On Page", rocketeerSlot.rktr_slot_id);
	  return null;
	}

	function formattedScheduleDate() {
	  var d = new Date();
	  var month = '' + (d.getMonth() + 1);
	  var day = '' + d.getDate();
	  var year = d.getFullYear();

	  if (month.length < 2) {
	    month = '0' + month;
	  }

	  if (day.length < 2) {
	    day = '0' + day;
	  }

	  return [year, month, day].join('');
	}

	function renderStaticAd(rocketeerSlots) {
	  var serverLogger = window.AdFuelUtils.getLogger('AdFuel', 'Static Ad Server', 'server', 'color: #4f86f7; padding: 2px', window.AdFuelOptions.ADFUEL.DEBUG || false);
	  serverLogger.log('Rocketeer Slots: ', rocketeerSlots);
	  var viewport = window.AdFuelUtils.getViewport();
	  var pageLevel = rocketeerSlots.splice(0, 1)[0];
	  var site = pageLevel.root;
	  var dateToday = formattedScheduleDate();
	  fetch("//i.cdn.turner.com/ads/adspaces/".concat(site, "/xxkz_assets.json?cacheBuster=").concat(window.AdFuelUtils.generateCacheBuster())).then(function (data) {
	    return data.json();
	  }).then(function (response) {
	    // var response = {"publishedAssets":[{"folder":"AdultSwim","filename":"20191107-20191108_ad_toolbox.png","fileStream":"true","isCCPA":"true","adSize":"300x250","startDate":"20191107","endDate":"20191108","assetUrl":"/www/ads/dev/adspaces/AdultSwim/CCPA/300x250/20191107-20191108_20191107-20191108_ad_toolbox.png"},{"folder":"AdultSwim","filename":"20191107-20191108_adFuel_modules.png","fileStream":"true","isCCPA":"true","adSize":"300x600","startDate":"20191107","endDate":"20191108","assetUrl":"/www/ads/dev/adspaces/AdultSwim/CCPA/300x600/20191107-20191108_adFuel_modules.png"},{"folder":"AdultSwim","filename":"20191111-20191115_adFuel_modules.png","fileStream":"true","isCCPA":"true","adSize":"970x250","startDate":"20191111","endDate":"20191115","assetUrl":"http://i.cdn.turner.com/ads/dev/adspaces/AdultSwim/CCPA/970x250/20191111-20191115_adFuel_modules.png"},{"folder":"AdultSwim","filename":"20191112-20191115_adFuel_modules.png","fileStream":"true","isCCPA":"true","adSize":"728x90","startDate":"20191112","endDate":"20191115","assetUrl":"http://i.cdn.turner.com/ads/dev/adspaces/AdultSwim/CCPA/728x90/20191112-20191115_adFuel_modules.png"}]};
	    var assets = response.publishedAssets;
	    serverLogger.log('CCPA Assets: ', assets);
	    rocketeerSlots.forEach(function (slotData) {
	      serverLogger.log('SlotData: ', slotData);
	      var sizes = slotData.sizes.map(function (size) {
	        return size.join('x');
	      });
	      var viewportReturned = false;
	      var responsizes = slotData.responsive.map(function (respViewport) {
	        // const viewportSize = respViewport[0].join('x');
	        var viewportSizes = respViewport[1].map(function (size) {
	          if (isArray$1(size)) return size.join('x');
	          return size;
	        });

	        if (respViewport[0][0] < viewport[0] && !viewportReturned) {
	          viewportReturned = true;
	          return viewportSizes;
	        }
	      }).filter(function (item) {
	        return typeof item !== 'undefined';
	      });
	      if (responsizes.length > 0) sizes = responsizes[0];

	      if (sizes[0] !== 'suppress') {
	        serverLogger.log('Requesting Static Ad For: ', {
	          site: site,
	          sizes: sizes
	        });
	        var eligibleAssets = assets.filter(function (asset) {
	          serverLogger.log('Checking Asset for Eligibility: ', asset);
	          serverLogger.log('Asset Ad Size: ', asset.adSize);
	          serverLogger.log('Slot Sizes: ', sizes);
	          serverLogger.log('Index: ', sizes.indexOf(asset.adSize));
	          serverLogger.log('Manual Index: ', sizes.indexOf('300x250'));
	          serverLogger.log('Checks: ', {
	            startDate: _parseInt$2(asset.startDate, 10) <= dateToday,
	            endDate: _parseInt$2(asset.endDate, 10) >= dateToday,
	            sizes: sizes.indexOf(asset.adSize) >= 0
	          });

	          if (_parseInt$2(asset.startDate, 10) <= dateToday && _parseInt$2(asset.endDate, 10) >= dateToday && sizes.indexOf(asset.adSize) >= 0) {
	            return true;
	          }
	        });
	        serverLogger.log('Eligible Assets: ', eligibleAssets);

	        if (eligibleAssets.length > 0) {
	          var randomAsset = eligibleAssets[Math.floor(Math.random() * eligibleAssets.length)];
	          var staticAd = document.createElement('img');
	          var mangledURL = randomAsset.assetUrl.replace('/www', '//i.cdn.turner.com') + "?cacheBuster=".concat(window.AdFuelUtils.generateCacheBuster());
	          serverLogger.log('Random Asset URL: ', mangledURL);
	          staticAd.src = mangledURL;
	          staticAd.style.width = randomAsset.adSize.split('x')[0] + 'px';
	          staticAd.style.height = randomAsset.adSize.split('x')[1] + 'px';
	          staticAd.className = 'adfuel-served';
	          var adContainer = document.getElementById(slotData.rktr_slot_id);

	          if (adContainer) {
	            serverLogger.log('Rendering Static Ad: ', randomAsset);

	            if (randomAsset.clickthruUrl) {
	              var clickAnchor = document.createElement('a');
	              clickAnchor.href = randomAsset.clickthruUrl;
	              clickAnchor.target = '_blank';
	              clickAnchor.rel = 'noreferrer noopener';
	              clickAnchor.appendChild(staticAd);
	              adContainer.appendChild(clickAnchor);
	            } else {
	              adContainer.appendChild(staticAd);
	            }
	          }
	        }
	      }
	    });
	  });
	}

	function _buildSlot(rocketeerSlot) {
	  var networkId = _options.networkId;
	  perf.mark('Building Slot [' + rocketeerSlot.rktr_slot_id + '] Start');
	  logger$1.group('Building Slot: ' + rocketeerSlot.rktr_slot_id);
	  logger$1.log('Slot Ad Unit: ', rocketeerSlot.rktr_ad_id);

	  if (rocketeerSlot.inherit && _inheritableAdUnit) {
	    // for inheritable slots, override adunit if there's something to inherit
	    rocketeerSlot.rktr_ad_id = _inheritableAdUnit;
	  }

	  var adPath = '/' + networkId + '/' + rocketeerSlot.rktr_ad_id;
	  var slotId = rocketeerSlot.rktr_slot_id;
	  var isOutOfPageSlot = rocketeerSlot.rktr_slot_id.indexOf('_oop') >= 1;
	  var action = isOutOfPageSlot ? 'Defining OOP Slot' : 'Defining Standard Slot';
	  var setSafeFrameConfig;

	  if (typeof rocketeerSlot.safeframe_config !== 'undefined') {
	    setSafeFrameConfig = rocketeerSlot.safeframe_config;
	  }

	  _googleApi.executeWhenAvailable(action, function () {
	    if (isOutOfPageSlot) {
	      _pageSlots[slotId] = _googleApi.defineOutOfPageSlot(adPath, slotId);
	    } else {
	      _pageSlots[slotId] = _googleApi.defineSlot(adPath, rocketeerSlot.sizes, slotId);
	    }

	    if (setSafeFrameConfig) {
	      _googleApi.setSlotSafeFrameConfig(_pageSlots[slotId], setSafeFrameConfig);
	    }
	  });

	  _googleApi.executeWhenAvailable('Defining slot targeting', function () {
	    var slotTargeting = _getCombinedSlotTargeting(rocketeerSlot);

	    logger$1.log('Defining Slot Targeting: ', rocketeerSlot.rktr_slot_id, slotTargeting);

	    keys$1(slotTargeting).forEach(function (target) {
	      var targetValue;

	      if (slotTargeting[target] && slotTargeting[target][1]) {
	        targetValue = stringify$1(slotTargeting[target][1]);
	      } else {
	        targetValue = '';
	      }

	      if (targetValue) {
	        targetValue = JSON.parse(targetValue);
	        var gptSlot = _pageSlots[slotId];

	        if (slotTargeting[target][0] === 'exclusions') {
	          if (isArray$1(slotTargeting[target][1])) {
	            keys$1(slotTargeting[target][1]).forEach(function (targetIndex) {
	              targetValue = slotTargeting[target][1][targetIndex];

	              _googleApi.setSlotCategoryExclusion(gptSlot, targetValue);
	            });
	          } else {
	            _googleApi.setSlotCategoryExclusion(gptSlot, targetValue);
	          }
	        } else {
	          var key = slotTargeting[target][0];

	          _googleApi.setSlotTargeting(gptSlot, key, targetValue);
	        }
	      }
	    });
	  });

	  logger$1.log('Checking Responsive Mapping For Slot', rocketeerSlot.responsive);
	  rocketeerSlot.responsive = rocketeerSlot.responsive || [];

	  if (rocketeerSlot.responsive.length > 0) {
	    _buildSlotMapping(rocketeerSlot.rktr_slot_id, rocketeerSlot.responsive);
	  }

	  _applySiteSlotTargeting(rocketeerSlot);

	  logger$1.groupEnd('Building Slot: ' + rocketeerSlot.rktr_slot_id);
	  perf.mark('Building Slot [' + rocketeerSlot.rktr_slot_id + '] End');
	  perf.measure('Building Slot [' + rocketeerSlot.rktr_slot_id + ']', 'Building Slot [' + rocketeerSlot.rktr_slot_id + '] Start', 'Building Slot [' + rocketeerSlot.rktr_slot_id + '] End');
	}

	function _buildSlots(rocketeerSlots, options) {
	  var buildSlotsPromise = new promise$1(function (resolve) {
	    /*
	      options:
	      ignoreCheck: false
	    */
	    function removeSlot(slot) {
	      var index = _rocketeerSlots.indexOf(slot);

	      if (index >= 0) {
	        _rocketeerSlots.splice(index, 1);
	      }
	    }

	    for (var slotIndex = 0; slotIndex < rocketeerSlots.length; slotIndex++) {
	      var rocketeerSlot = rocketeerSlots[slotIndex];
	      var ignoreRenderCheck = options && options.ignoreCheck;
	      var buildSlot = true;

	      if (!ignoreRenderCheck) {
	        // renderCheck may return an updatedSlot or null
	        // if it updates the slot, it will modify rocketeerSlot
	        if (!_renderCheck(rocketeerSlot)) {
	          // remove slot, which is no longer valid
	          removeSlot(rocketeerSlot);
	          buildSlot = false;
	        }
	      }

	      if (buildSlot) {
	        var builtSlotIds = _builtSlots.map(function (slot) {
	          return slot.rktr_slot_id;
	        });

	        logger$1.log('Previously built slots: ', builtSlotIds);

	        if (builtSlotIds.indexOf(rocketeerSlot.rktr_slot_id) < 0) {
	          _buildSlot(rocketeerSlot);

	          _builtSlots.push(rocketeerSlot);

	          _queuedSlots.push(rocketeerSlot);

	          removeSlot(rocketeerSlot);
	        } else {
	          logger$1.log('Slot is already built: ', rocketeerSlot);
	        }
	      }
	    }

	    resolve(_builtSlots);
	  });
	  return buildSlotsPromise;
	} // clear slots- optional slotIds (object or array)


	function clearSlots(slotIds) {
	  var slotIdsClone = slotIds || [];

	  if (!isArray$1(slotIdsClone)) {
	    slotIdsClone = [slotIds];
	  }

	  logger$1.log('Clearing Slots', {
	    slotDivIds: slotIdsClone
	  });

	  _googleApi.executeWhenAvailable('clearing slots', function () {
	    // convert to slots
	    // what if passed slotIds are invalid?
	    var slots = [];

	    if (slotIdsClone.length > 0) {
	      slots = slotIdsClone.filter(function (slotId) {
	        return !!_pageSlots[slotId];
	      }).map(function (slotId) {
	        return _pageSlots[slotId];
	      });

	      if (slots.length === 0) {
	        return;
	      }
	    }

	    _googleApi.clearSlots(slots);
	  });
	} // destroy slots- optional slotIds (object or array)


	function destroySlots(slotIds) {
	  var slotIdsClone = slotIds || [];

	  if (!isArray$1(slotIdsClone)) {
	    slotIdsClone = [slotIds];
	  }

	  logger$1.log('Destroying Slots', {
	    slotDivIds: slotIds
	  });

	  _googleApi.executeWhenAvailable('destroying slots', function () {
	    // convert to slots
	    // what if passed slotIds are invalid?
	    var slots = [];

	    if (slotIdsClone.length > 0) {
	      slots = slotIdsClone.filter(function (slotId) {
	        return !!_pageSlots[slotId];
	      }).map(function (slotId) {
	        return _pageSlots[slotId];
	      });

	      if (slots.length === 0) {
	        return;
	      }
	    }

	    _removeSlotRenderedClass(slotIdsClone);

	    if (typeof window.jpUnloadUnits !== 'undefined') {
	      window.jpUnloadUnits();
	    }

	    _googleApi.destroySlots(slots);

	    _removePageSlots(slotIdsClone);

	    _removeRocketeerSlots(slotIdsClone);
	  });
	}

	function _buildSlotMapping(slotId, responsiveMap) {
	  // transform responsiveMap- convert string values to integers, allow for "suppress"
	  for (var i = 0; i < responsiveMap.length; i++) {
	    var val = JSON.parse(stringify$1(responsiveMap[i]));

	    for (var x = 0; x < val.length; x++) {
	      if (isArray$1(val[x])) {
	        for (var y = 0; y < val[x].length; y++) {
	          if (isArray$1(val[x][y])) {
	            for (var z = 0; z < val[x][y].length; z++) {
	              if (val[x][y][z] !== 'fluid') {
	                val[x][y][z] = _parseInt$2(val[x][y][z], 10);
	              }
	            }
	          } else if (_parseInt$2(val[x][y], 10) >= 0) {
	            val[x][y] = _parseInt$2(val[x][y], 10);
	          } else if (val[x][y] !== 'fluid') {
	            val[x] = [];
	          }
	        }
	      } else {
	        val[x] = [];
	      }
	    }

	    responsiveMap[i] = val;
	  }

	  _googleApi.executeWhenAvailable('setting slot mappings', function () {
	    _googleApi.defineSlotSizeMapping(_pageSlots[slotId], responsiveMap);
	  });
	}

	function _updateSlot(slot, ignoreCount) {
	  var origSlotId = slot.rktr_slot_id;
	  var newSlotId = origSlotId;
	  var idArray = origSlotId.split('_');
	  var incrementer = idArray[idArray.length - 1];
	  var pageDivs = document.querySelectorAll('div#' + origSlotId);

	  if (pageDivs.length > 1 || pageDivs.length === 1 && ignoreCount) {
	    logger$1.log('updating slot div id.', {
	      slot: slot
	    });

	    while (_pageSlots[newSlotId]) {
	      // slot exists, so increment
	      if (idArray.length === 3) {
	        incrementer = window.AdFuelUtils.generateCacheBuster();
	      } else {
	        incrementer = _parseInt$2(incrementer, 10) + 1;

	        if (incrementer < 10) {
	          incrementer = '0' + String(incrementer);
	        } else {
	          incrementer = String(incrementer);
	        }
	      }

	      idArray[idArray.length - 1] = incrementer;
	      newSlotId = idArray.join('_');
	    }

	    _updateSlotId(slot, newSlotId, origSlotId);

	    _updateDivId(origSlotId, newSlotId);
	  }

	  return slot;
	}

	function _updateSlotId(slot, newSlotId, origSlotId) {
	  slot.rktr_slot_id = newSlotId;

	  try {
	    var SlotIDChangeEvent = new CustomEvent('SlotIdChange', {
	      detail: {
	        asset: slot,
	        originalId: origSlotId,
	        newId: newSlotId
	      }
	    });
	    document.dispatchEvent(SlotIDChangeEvent);
	  } catch (ex) {
	    logger$1.error('error dispatching custom Event: SlotIdChange', {
	      error: ex
	    });
	  }
	}

	function _updateDivId(origSlotId, newSlotId) {
	  var pageDivs = document.querySelectorAll('div#' + origSlotId);

	  if (pageDivs.length > 0) {
	    for (var slotIndex = 0; slotIndex < pageDivs.length; slotIndex++) {
	      var el = pageDivs[slotIndex];

	      if (el.className.indexOf('adfuel-rendered') < 0 && pageDivs.length > 1 || pageDivs.length === 1) {
	        el.id = newSlotId;
	      }
	    }
	  }
	}

	function _isQueueDispatchable() {
	  return _initialized && _preQueueExecuting === false;
	} // executed from init and ready, queue is only dispatchable once


	function _dispatchAllQueues() {
	  if (_isQueueDispatchable()) {
	    if (_delayedDispatchQueues.length > 0 || _userDispatchedQueues.length > 0) {
	      logger$1.log('Processing delayed dispatch queues'); // process all delayed dispatch queue functions

	      var i;

	      for (i = 0; i < _delayedDispatchQueues.length; i++) {
	        _delayedDispatchQueues[i]();
	      }

	      for (i = 0; i < _userDispatchedQueues.length; i++) {
	        _userDispatchedQueues[i]();
	      }

	      _delayedDispatchQueues.length = 0;
	      _userDispatchedQueues.length = 0;
	      dispatchQueue();
	    } else if (_options.autoDispatch) {
	      logger$1.log('Processing all queues'); // dispatch whatever has been queued

	      dispatchQueue();
	    }
	  } else {
	    _delayingDispatch = true;
	  }
	}

	function dispatchQueue(dispatchOptions) {
	  /*
	            dispatchOptions:
	            preDispatchCallback
	            postDispatchCallback
	            ignoreCheck: false
	            sync: false
	            syncSlots: []
	            slots: []
	            exclude: []
	            maintainCorrelator: true
	            */
	  if (!_isQueueDispatchable()) {
	    perf.mark('Delaying Queue Dispatch');
	    logger$1.log('Delaying Queue Dispatch');
	    _delayingDispatch = true;

	    _delayedDispatchQueues.push(function () {
	      dispatchQueue(dispatchOptions);
	    });

	    return;
	  }

	  perf.mark('Dispatch Queue Start');
	  var dispatchOpts = dispatchOptions || {
	    sync: false,
	    maintainCorrelator: true
	  };

	  if (dispatchOpts.slots && dispatchOpts.slots.length > 0) {
	    for (var slotIndex = 0; slotIndex < dispatchOpts.slots.length; slotIndex++) {
	      if (_excludedSlotIds.indexOf(dispatchOpts.slots[slotIndex]) >= 0) {
	        _excludedSlotIds.splice(_excludedSlotIds.indexOf(dispatchOpts.slots[slotIndex]), 1);
	      }
	    }
	  }

	  if (_rocketeerSlots.length > 0) {
	    // display all slots or just the ones in requestOptions.slots
	    // exclude any in requestOptions.exclude
	    // if requestOptions.slots are not provided, ensure rocketeer slot is not in _excludeSlotIds (set via QueueRegistery/options.exclude)
	    // remove excluded slot ids if explicitly requested
	    if (dispatchOpts.slots && dispatchOpts.slots.length > 0 && _excludedSlotIds.length > 0) {
	      for (var i = 0; i < dispatchOpts.slots.length; i++) {
	        var indexToRemove = _excludedSlotIds.indexOf(dispatchOpts.slots[i]);

	        if (indexToRemove >= 0) {
	          _excludedSlotIds.splice(indexToRemove, 1);
	        }
	      }
	    }

	    logger$1.log('Built Slots: ', _builtSlots);

	    if (_builtSlots.length > 0) {
	      // wait on all registered modules- passing clone of slotQueue
	      var builtSlotsClone = _builtSlots;
	      builtSlotsClone = builtSlotsClone.filter(function (slot) {
	        var filter = typeof slot.dispatched === 'undefined' || slot.dispatched === false;
	        return filter;
	      });
	      var builtSlotIds = [];

	      for (var slotId = 0; slotId < builtSlotsClone.length; slotId++) {
	        var slot = builtSlotsClone[slotId];
	        slot.dispatched = true;
	        _builtSlots[slotId] = slot;
	        builtSlotIds.push(slot.rktr_slot_id);
	      }

	      if (builtSlotIds.length > 0) {
	        executeModuleCallbacks('preDispatchCallback', builtSlotsClone, builtSlotsClone, dispatchOptions).then(function () {
	          try {
	            var PreDispatchCompleteEvent = new CustomEvent('PreDispatchComplete', {
	              detail: {
	                slots: _rocketeerSlots.length
	              }
	            });
	            document.dispatchEvent(PreDispatchCompleteEvent);
	          } catch (ex) {
	            logger$1.error('error dispatching custom Event: PreDispatchComplete', {
	              error: ex
	            });
	          }

	          _buildPageLevelGPTObject();

	          logger$1.log('preDispatchCallback events completed.  Sending request.');

	          _sendRequest(builtSlotsClone, dispatchOptions).then(function (displayedSlots) {
	            perf.mark('Dispatch Queue End');
	            perf.measure('Dispatch Queue', 'Dispatch Queue Start', 'Dispatch Queue End');
	            logger$1.log('Displayed Slots: ', displayedSlots);

	            for (var index = 0; index < _queuedSlots.length; index++) {
	              var slot = _queuedSlots[index];

	              if (builtSlotIds.indexOf(slot.rktr_slot_id) >= 0) {
	                _queuedSlots.splice(index, 1);

	                index--;
	              }
	            }
	          });
	        });
	      } else {
	        logger$1.log('No undispatched slots.');
	      }
	    }
	  }
	}

	var loadJSON = function _loadJSON(url, callback) {
	  perf.mark('Registry Load [' + url + '] Start');
	  var parser = document.createElement('a');
	  parser.href = url;
	  var pathname = parser.pathname.replace(/(\.min)?(\.js)$/, '.json');
	  var jsonURL = parser.protocol + '//' + window.AdFuelUtils.cdnRoot + (pathname.indexOf('/') === 0 ? pathname : '/' + pathname);
	  var req = new XMLHttpRequest();

	  req.onload = function () {
	    var data;

	    try {
	      var registry = JSON.parse(this.response).registry;
	      logger$1.log('JSON Parse Complete: ', registry);
	      perf.mark('Registry Load [' + url + '] End');
	      perf.measure('Registry Load [' + url + ']', 'Registry Load [' + url + '] Start', 'Registry Load [' + url + '] End');
	      data = {
	        response: registry,
	        error: false
	      };
	      callback(data);
	    } catch (err) {
	      logger$1.log('JSON Parse Failed: ', err);
	      data = {
	        response: this.response,
	        error: true
	      };
	      callback(data);
	    }
	  };

	  try {
	    logger$1.log('Requesting JSON: ', jsonURL);
	    req.open('GET', jsonURL, true);
	    req.send();
	  } catch (err) {
	    logger$1.log('JSON Request Failed: ', err);
	    var data = {
	      response: this.response,
	      error: true
	    };
	    callback(data);
	  }
	};

	function queueRegistry(url, queueOptions) {
	  /*
	             queueOptions:
	            preDispatchCallback
	            postDispatchCallback
	            sync: false
	            exclude: []
	            syncSlots: []
	            slots: []
	            maintainCorrelator: true
	            dispatch: false  (options.autodispatch is ignored)
	            slotMap: {}
	     */
	  getFilterValue().then(function (shouldFilter) {
	    logger$1.log('Queueing Registry: ', url, queueOptions, _options);

	    if (!url) {
	      logger$1.error('Empty Registry url');
	      return;
	    }

	    var queueOpts = queueOptions || {
	      // set based on autoDispatch
	      dispatch: _options.autoDispatch
	    };

	    if (queueOpts.exclude && queueOpts.exclude.length > 0) {
	      // add non-duplicating exclude slotIds
	      for (var i = 0; i < queueOpts.exclude.length; i++) {
	        var slotId = queueOpts.exclude[i];

	        if (_excludedSlotIds.indexOf(slotId) < 0) {
	          logger$1.log('Excluding Slot: ', slotId);

	          _excludedSlotIds.push(slotId);
	        }
	      }
	    }

	    function addScriptTag(urlParam) {
	      var scriptA = document;
	      var scriptB = scriptA.createElement('script');
	      var scriptC = scriptA.getElementsByTagName('script')[0];
	      var scriptD = /^(complete|loaded)$/;
	      var scriptE = false;
	      scriptB.type = 'text/javascript';
	      scriptB.src = urlParam;

	      scriptB.onload = scriptB.onreadystatechange = function () {
	        if (!scriptE && !('readyState' in scriptB && scriptD.test(scriptB.readyState))) {
	          scriptB.onload = scriptB.onreadystatechange = null;
	          scriptE = true;
	          scriptComplete();
	        }
	      };

	      scriptC.parentNode.insertBefore(scriptB, scriptC);
	    }

	    function scriptComplete() {
	      perf.mark('Registry Load [' + url + '] End');
	      perf.measure('Registry Load [' + url + ']', 'Registry Load [' + url + '] Start', 'Registry Load [' + url + '] End');

	      if (queueOpts.dispatch) {
	        dispatchQueue(queueOpts);
	      }
	    }

	    function filterSlots(registry, slots) {
	      var returnData = [];
	      returnData.push(registry[0]);

	      if (slots && slots.length > 0) {
	        for (var x = 1; x < registry.length; x++) {
	          if (slots.indexOf(registry[x].rktr_slot_id) >= 0) {
	            returnData.push(registry[x]);
	          }
	        }
	      } else {
	        returnData = registry;
	      }

	      return returnData;
	    }

	    var normalizedUrl = normalizeUrl(url);

	    function requestComplete(data) {
	      if (data.error === true) {
	        logger$1.log('Using Script Tag Method...');
	        addScriptTag(url);
	      } else {
	        var filteredResponse = filterSlots(data.response, queueOpts.slots);
	        logger$1.log('Response: ', data.response);
	        _cachedRegistries[normalizedUrl] = data.response;
	        AdFuel.registry.push(filteredResponse, queueOpts);
	      }
	    }

	    if (_cachedRegistries[normalizedUrl]) {
	      logger$1.log('Queueing Cached Registry: ', _cachedRegistries[normalizedUrl], queueOpts);
	      var filteredResponse = filterSlots(_cachedRegistries[normalizedUrl], queueOpts.slots);
	      AdFuel.registry.push(filteredResponse, queueOpts);
	    } else {
	      logger$1.log('Requesting Registry: ', normalizedUrl, queueOpts);
	      loadJSON(url, requestComplete);
	    }
	  });
	}

	function _startInterval(length, steps, oninterval) {
	  var stepsClone = steps || 10;
	  var speed = length / stepsClone;
	  var count = 0;

	  var start = now$1();

	  function instance() {
	    if (count++ === stepsClone) {
	      // return true to continue repeating
	      var continueInterval = oninterval();

	      if (continueInterval) {
	        _startInterval(length, stepsClone, oninterval);
	      }
	    } else {
	      // wait longer, basing delay upon remaining time
	      var diff = now$1() - start - count * speed;
	      window.setTimeout(instance, speed - diff);
	    }
	  }

	  window.setTimeout(instance, speed);
	}

	function refresh(slotIds, refreshOptions) {
	  /***
	    slotIds: optional array to refresh (empty/null=refresh all)
	     refreshOptions:
	      pageload: BOOLEAN (default is true)
	      interval: INT
	      preRefreshCallback: function (optional)
	      postRefreshCallback: function (optional)
	      maintainCorrelator: BOOLEAN (default is true)
	  ***/
	  perf.mark('Refresh Called');
	  var refreshOpts = refreshOptions || {};
	  var slotIdsClone = slotIds || [];

	  if (slotIds && !isArray$1(slotIds) && !refreshOptions) {
	    // assume user passed refreshOptions as first argument
	    refreshOpts = slotIds;
	    slotIdsClone = [];
	  }

	  var monetization;
	  var monetizedAssets = [];

	  var rocketeerSlotsToRefresh = _rocketeerSlots.filter(function (slot) {
	    if (slotIdsClone.length === 0) {
	      monetization = window.AdFuelUtils.isMonetized(slot);

	      if (slot.rktr_slot_id !== 'page' && monetization.isMonetized) {
	        slot.monetization = monetization;
	        monetizedAssets.push(slot);
	      }

	      return true;
	    }

	    if (slotIds.length > 0 && slotIds.indexOf(slot.rktr_slot_id) >= 0) {
	      monetization = window.AdFuelUtils.isMonetized(slot);

	      if (slot.rktr_slot_id !== 'page' && monetization.isMonetized) {
	        slot.monetization = monetization;
	        monetizedAssets.push(slot);
	      }

	      return true;
	    }

	    return false;
	  });

	  logger$1.log('Monetized Assets: ', monetizedAssets);
	  logger$1.log(''); // default pageload to true

	  refreshOpts.interval = refreshOpts.interval || 0;
	  refreshOpts.pageload = typeof refreshOpts.pageload === 'undefined' ? true : refreshOpts.pageload;
	  refreshOpts.maintainCorrelator = typeof refreshOpts.maintainCorrelator === 'undefined' ? true : refreshOpts.maintainCorrelator;

	  var refreshSlots = function refreshSlots(monetizedAssets, rocketeerSlotsToRefresh) {
	    {
	      var slotsToRefresh = [];
	      var slotIdsToRefresh = [];
	      var slotIdsToCheck = [];

	      if (slotIdsClone.length === 0) {
	        // refresh all- build list allowing for repeated iterations via interval option
	        keys$1(_pageSlots).forEach(function (slotId) {
	          slotIdsToCheck.push(slotId);
	        });
	      } else {
	        slotIdsToCheck = slotIdsClone;
	      }

	      for (var i = 0; i < slotIdsToCheck.length; i++) {
	        var slotIdVal = slotIdsToCheck[i];

	        if (document.getElementById(slotIdVal)) {
	          var slot = _pageSlots[slotIdVal];

	          if (slot) {
	            slotsToRefresh.push(slot);
	            slotIdsToRefresh.push(slotIdVal);
	          }
	        } else {
	          logger$1.log('Cannot find element on page to refresh: ' + slotIdVal);
	        }
	      }

	      if (slotIdsClone.length > 0 && slotIdsToRefresh.length === 0) {
	        // caller sent all invalid slotIds to refresh, so do nothing
	        return;
	      }

	      logger$1.log('Callback Parameters: ', {
	        name: 'preRefreshCallback',
	        monetization: monetizedAssets,
	        slots: rocketeerSlotsToRefresh,
	        options: refreshOpts
	      });
	      executeModuleCallbacks('preRefreshCallback', monetizedAssets, rocketeerSlotsToRefresh, refreshOpts).then(function () {
	        try {
	          var PreRefreshCompleteEvent = new CustomEvent('PreRefreshComplete', {
	            detail: {
	              slots: slotIdsToRefresh
	            }
	          });
	          document.dispatchEvent(PreRefreshCompleteEvent);
	        } catch (ex) {
	          logger$1.error('error dispatching custom Event: PreRefreshComplete', {
	            error: ex
	          });
	        }

	        clearSlots(slotIdsToRefresh);

	        if (refreshOpts.pageload) {
	          _googleApi.setTargeting('pageload', 'ref');
	        } else {
	          _googleApi.clearTargeting('pageload');
	        }

	        _googleApi.refreshSlots(slotsToRefresh, refreshOpts);
	      });
	    }
	  };

	  function startInterval(interval) {
	    logger$1.log('starting refresh interval: ' + interval, refreshOptions);
	    var intervalInMilliseconds = interval * 1000;

	    _startInterval(intervalInMilliseconds, 5, function () {
	      // if the interval has been removed, stop repeating
	      if (!refreshOptions.interval || _parseInt$2(refreshOptions.interval, 10) === 0) {
	        logger$1.log('stopping refresh interval: ' + interval, refreshOptions);
	        return false;
	      } // if the interval has changed, start new interval and stop repeating


	      var currentInterval = _parseInt$2(refreshOptions.interval, 10);

	      if (interval !== currentInterval) {
	        logger$1.log('changing refresh interval: ' + interval, refreshOptions);
	        startInterval(currentInterval);
	        return false;
	      } // interval has been reached, so refresh spots


	      refreshSlots(monetizedAssets, rocketeerSlotsToRefresh); // repeat interval

	      return true;
	    });
	  }

	  if (refreshOpts.interval && _parseInt$2(refreshOpts.interval, 10) > 0) {
	    var interval = _parseInt$2(refreshOptions.interval, 10);

	    startInterval(interval);
	  } else {
	    refreshSlots(monetizedAssets, rocketeerSlotsToRefresh);
	  }
	} // combined google APIs
	// TODO - Pull this out and put in the Googletag module.
	// This will provide for better abstraction of the ads API and will make switching ad servers easier.


	var _googleApi = function createGoogleAPI() {
	  var _pubAdsConfiged = false;
	  var _isGPTAvailable = false;

	  function isAvailable(action, obj) {
	    if (!_isGPTAvailable) {
	      _isGPTAvailable = window.googletag.apiReady && typeof window.googletag.pubads === 'function';

	      if (!_isGPTAvailable && action) {
	        logger$1.error('GPT is unavailable - ' + action, obj);
	      }
	    }

	    return _isGPTAvailable;
	  }

	  function executeWhenAvailable(action, fn) {
	    window.googletag.cmd.push(fn);
	  }

	  function configurePubAds() {
	    return new promise$1(function (resolve) {
	      if (!_pubAdsConfiged) {
	        // only execute once
	        _pubAdsConfiged = true;
	        window.googletag.cmd.push(function pushGPTServices() {
	          window.googletag.pubads().addEventListener('impressionViewable', function _impressionViewableFunc(event) {
	            perf.mark('Slot Viewable [' + (event.slot ? event.slot.getSlotElementId() : 'NO ID') + ']');
	            var slotViewableEvent = new CustomEvent('SlotViewable', {
	              detail: event
	            });
	            document.dispatchEvent(slotViewableEvent);
	          });
	          window.googletag.pubads().addEventListener('slotVisibilityChanged', function (event) {
	            var slotVisibilityChanged = new CustomEvent('SlotVisibilityChanged', {
	              detail: event.detail
	            });
	            document.dispatchEvent(slotVisibilityChanged);
	          });
	          window.googletag.pubads().addEventListener('slotRenderEnded', function (event) {
	            perf.mark('Ad Rendered [' + (event.slot ? event.slot.getSlotElementId() : 'NO ID') + ']');

	            try {
	              var detail = {};
	              detail.asset = event.slot || null;
	              detail.pos = event.slot ? event.slot.getTargeting('pos') : [''];
	              detail.empty = !!event.isEmpty;
	              detail.renderedSize = event.size ? event.size : '0x0';
	              detail.creativeId = event.creativeId ? event.creativeId : '0';
	              detail.lineItemId = event.lineItemId ? event.lineItemId : '0';
	              detail.serviceName = event.serviceName ? event.serviceName : '';
	              detail.divId = event.slot ? event.slot.getSlotElementId() : 'NO ID';

	              if (detail.empty && siteOptions.ADFUEL.COLLAPSE_EMPTY_DIVS === false) {
	                logger$1.log('Collapsing Empty Div...', detail.divId);
	                var el = document.getElementById(detail.divId);
	                el.style.display = 'none';
	              }

	              var creativeIds = window.googletag && typeof window.googletag.pubads === 'function' ? window.googletag.pubads().getTargeting('creativeId') : [];
	              var lineItemIds = window.googletag && typeof window.googletag.pubads === 'function' ? window.googletag.pubads().getTargeting('lineItemId') : [];

	              if (event.creativeId && creativeIds.indexOf(event.creativeId) < 0) {
	                creativeIds.push(event.creativeId);
	              }

	              if (event.lineItemId && lineItemIds.indexOf(event.lineItemId) < 0) {
	                lineItemIds.push(event.lineItemId);
	              }

	              window.googletag.cmd.push(function () {
	                window.googletag.pubads().setTargeting('creativeId', creativeIds);
	                window.googletag.pubads().setTargeting('lineItemId', lineItemIds);
	              });
	              var renderCompleteEvent = new CustomEvent('GPTRenderComplete', {
	                detail: detail
	              });
	              document.dispatchEvent(renderCompleteEvent);
	            } catch (ex) {
	              logger$1.error('error dispatching custom Event: GPTRenderComplete', {
	                error: ex
	              });
	            }
	          });
	          window.googletag.pubads().addEventListener('slotOnload', function (event) {
	            perf.mark('Slot Loaded [' + (event.slot ? event.slot.getSlotElementId() : 'NO ID') + ']');
	            var gptSlotLoaded = new CustomEvent('GPTSlotLoaded', {
	              detail: event
	            });
	            document.dispatchEvent(gptSlotLoaded);
	          });
	          logger$1.log("Enabling 'Collapse Empty Divs'");
	          window.googletag.pubads().collapseEmptyDivs(true);
	          logger$1.log("Enabling 'Async Rendering'");
	          window.googletag.pubads().enableAsyncRendering();
	          logger$1.log("Enabling 'Single Request'");
	          window.googletag.pubads().enableSingleRequest();

	          if (!window.AdFuelUtils.getURLParam('enableInitialLoad')) {
	            logger$1.log("Disabling 'Initial Load'");
	            window.googletag.pubads().disableInitialLoad();
	          }

	          var consentRegion = window.AdFuelUtils.getUserConsentRegion();
	          var consentStatus = window.AdFuelUtils.getConsent();

	          if (consentRegion === 'ccpa' && !consentStatus) {
	            window.googletag.pubads().setPrivacySettings({
	              restrictDataProcessing: true
	            });
	          }

	          logger$1.log("Enabling 'Services'");
	          window.googletag.enableServices();
	          resolve();
	        });
	      } else {
	        resolve();
	      }
	    });
	  }

	  function clearTargeting(key) {
	    var success = false;

	    if (isAvailable('clearing target', {
	      key: key || 'all'
	    })) {
	      if (key) {
	        window.googletag.cmd.push(function () {
	          window.googletag.pubads().clearTargeting(key);
	        });
	      } else {
	        window.googletag.cmd.push(function () {
	          window.googletag.pubads().clearTargeting();
	        });
	      }

	      success = true;
	    }

	    return success;
	  }

	  function setTargeting(key, value) {
	    var success = false;

	    if (isAvailable('setting target', {
	      key: key,
	      value: value
	    })) {
	      // this was in refresh() to setTargeting
	      AdFuel.requestScriptText += "googletag.pubads().setTargeting('" + key + "', '" + value + "');\n";
	      window.googletag.cmd.push(function () {
	        window.googletag.pubads().setTargeting(key, value);
	      });
	      success = true;
	    }

	    return success;
	  }

	  function setLocation(latitude, longitude) {
	    var success = false;

	    if (isAvailable('setting location', {
	      latitude: latitude,
	      logitude: longitude
	    })) {
	      window.googletag.cmd.push(function () {
	        window.googletag.pubads().setLocation(latitude, longitude);
	      });
	      success = true;
	    }

	    return success;
	  }

	  function setChildDirectedTreatmentTag(value) {
	    var success = false;

	    if (isAvailable('setting child directed treatment tag: ' + value)) {
	      window.googletag.cmd.push(function () {
	        window.googletag.pubads().clearTagForChildDirectedTreatment();
	        window.googletag.pubads().setTagForChildDirectedTreatment(value);
	      });
	      success = true;
	    }

	    return success;
	  }

	  function setSafeFrameConfig(value) {
	    var success = false;
	    value.sandbox = value.sandbox === true || value.sandbox === 'true';
	    value.allowOverlayExpansion = value.allowOverlayExpansion === true || value.allowOverlayExpansion === 'true';
	    value.allowPushExpansion = value.allowPushExpansion === true || value.allowPushExpansion === 'true';

	    if (value.sandbox !== true) {
	      logger$1.log('Removing invalid sandbox value');
	      delete value.sandbox;
	    }

	    if (isAvailable('setting SafeFrame config tag: ' + value)) {
	      window.googletag.cmd.push(function () {
	        window.googletag.pubads().setSafeFrameConfig(value);
	      });
	      success = true;
	    }

	    return success;
	  }

	  function setCategoryExclusion(value) {
	    var success = false;

	    if (isAvailable('setting category exclusion: ' + value)) {
	      AdFuel.requestScriptText += "googletag.pubads().setCategoryExclusion('" + value + "');\n";
	      window.googletag.cmd.push(function () {
	        window.googletag.pubads().setCategoryExclusion(value);
	      });
	      success = true;
	    }

	    return success;
	  }

	  function defineOutOfPageSlot(adPath, slotId) {
	    var result = false;

	    if (isAvailable('defining out of page slot', {
	      adPath: adPath,
	      slotId: slotId
	    })) {
	      logger$1.log('Building OOP Slot Object', {
	        adPath: adPath,
	        slotId: slotId
	      });
	      AdFuel.requestScriptText += "\n_pageSlots['" + slotId + "'] = googletag.defineOutOfPageSlot('" + adPath + "', '" + slotId + "').addService(googletag.pubads());\n";
	      result = window.googletag.defineOutOfPageSlot(adPath, slotId);

	      if (result) {
	        result.addService(window.googletag.pubads());
	      } else {
	        logger$1.warn('Could not define OOP Slot: ', adPath, slotId);
	      }
	    }

	    return result;
	  }

	  function defineSlot(adPath, sizes, slotId) {
	    var result = false;

	    if (isAvailable('defining standard slot', {
	      adPath: adPath,
	      sizes: sizes,
	      slotId: slotId
	    })) {
	      logger$1.log('Building Standard Slot Object', {
	        adPath: adPath,
	        sizes: sizes,
	        slotId: slotId
	      });
	      AdFuel.requestScriptText += "\n_pageSlots['" + slotId + "'] = googletag.defineSlot('" + adPath + "', " + stringify$1(sizes) + ", '" + slotId + "').addService(googletag.pubads());\n";
	      result = window.googletag.defineSlot(adPath, sizes, slotId);

	      if (result) {
	        result.addService(window.googletag.pubads());
	      } else {
	        logger$1.warn('Could not define Slot: ', adPath, sizes, slotId, result);
	      }
	    }

	    return result;
	  }

	  function setSlotCategoryExclusion(slot, value) {
	    if (slot) {
	      var slotId = slot.getSlotElementId();
	      logger$1.log('Setting Slot Category Exclusion', {
	        slotId: slotId,
	        value: value
	      });
	      AdFuel.requestScriptText += "_pageSlots['" + slotId + "'].setCategoryExclusion('" + value + "');\n";
	      slot.setCategoryExclusion(value);
	    }
	  }

	  function setSlotTargeting(slot, key, value) {
	    if (slot) {
	      var slotId = slot.getSlotElementId();
	      logger$1.log('Setting Slot Targeting', {
	        slotId: slotId,
	        key: key,
	        value: value
	      });
	      AdFuel.requestScriptText += "_pageSlots['" + slotId + "'].setTargeting('" + key + "', '" + value + "');\n";
	      slot.setTargeting(key, value);
	    }
	  }

	  function setSlotSafeFrameConfig(slot, value) {
	    if (slot) {
	      var slotId = slot.getSlotElementId();
	      logger$1.log('Setting Slot SafeFrame config', {
	        slotId: slotId,
	        value: value
	      });
	      AdFuel.requestScriptText += "_pageSlots['" + slotId + "'].setSafeFrameConfig(" + value + ');\n';
	      slot.setSafeFrameConfig(value);
	    }
	  }

	  function defineSlotSizeMapping(slot, responsiveMap) {
	    if (slot) {
	      var slotId = slot.getSlotElementId();
	      logger$1.log('Setting Slot size mapping', {
	        slotId: slotId,
	        responsiveMap: responsiveMap
	      });
	      AdFuel.requestScriptText += "_pageSlots['" + slotId + "'].defineSizeMapping('" + stringify$1(responsiveMap) + "');\n";
	      slot.defineSizeMapping(responsiveMap);
	    }
	  }

	  function displaySlotById(slotId) {
	    AdFuel.requestScriptText += 'googletag.display("' + slotId + '");\n';
	    window.googletag.cmd.push(function () {
	      window.googletag.display(slotId);
	    });
	  }

	  function clearSlotTargeting(slot) {
	    if (slot) {
	      var slotId = slot.getSlotElementId();
	      logger$1.log('Clearing targeting for Slot: ' + slotId);
	      AdFuel.requestScriptText += "_pageSlots['" + slotId + "'].clearTargeting();\n";
	      slot.clearTargeting();
	    }
	  }

	  function clearGPTSlots(slots) {
	    var slotIds = slots.length === 0 ? 'all' : slots.map(function (slot) {
	      return slot ? slot.getSlotElementId() : 'NO ID';
	    }).join(',');
	    AdFuel.requestScriptText += 'googletag.pubads().clear(' + slotIds + ');\n';

	    if (slots.length > 0) {
	      window.googletag.cmd.push(function () {
	        window.googletag.pubads().clear(slots);
	      });
	    } else {
	      window.googletag.cmd.push(function () {
	        window.googletag.pubads().clear();
	      });
	    }
	  }

	  function destroyGPTSlots(slots) {
	    var slotIds = slots.length === 0 ? 'all' : slots.map(function (slot) {
	      return slot ? slot.getSlotElementId() : 'NO ID';
	    }).join(',');
	    AdFuel.requestScriptText += 'googletag.pubads().destroySlots(' + slotIds + ');\n';

	    if (slots.length > 0) {
	      window.googletag.cmd.push(function () {
	        window.googletag.destroySlots(slots);
	      });
	    } else {
	      window.googletag.cmd.push(function () {
	        window.googletag.destroySlots();
	      });
	    }
	  }

	  function refreshSlots(slots, options) {
	    var opts = options || {
	      maintainCorrelator: true
	    };
	    var slotIds = slots.length === 0 ? 'all' : slots.map(function (slot) {
	      return slot ? slot.getSlotElementId() : 'NO ID';
	    }).join(',');
	    AdFuel.requestScriptText += 'googletag.pubads().refresh(' + slotIds + ');\n';

	    if (slots.length > 0) {
	      window.googletag.cmd.push(function () {
	        window.googletag.pubads().refresh(slots, {
	          changeCorrelator: !opts.maintainCorrelator
	        });
	      });
	    } else {
	      window.googletag.cmd.push(function () {
	        window.googletag.pubads().refresh(null, {
	          changeCorrelator: !opts.maintainCorrelator
	        });
	      });
	    }
	  }

	  return {
	    executeWhenAvailable: executeWhenAvailable,
	    isAvailable: isAvailable,
	    configurePubAds: configurePubAds,
	    clearTargeting: clearTargeting,
	    setTargeting: setTargeting,
	    setLocation: setLocation,
	    setChildDirectedTreatmentTag: setChildDirectedTreatmentTag,
	    setSafeFrameConfig: setSafeFrameConfig,
	    setSlotSafeFrameConfig: setSlotSafeFrameConfig,
	    setCategoryExclusion: setCategoryExclusion,
	    defineOutOfPageSlot: defineOutOfPageSlot,
	    defineSlot: defineSlot,
	    setSlotCategoryExclusion: setSlotCategoryExclusion,
	    setSlotTargeting: setSlotTargeting,
	    displaySlotById: displaySlotById,
	    defineSlotSizeMapping: defineSlotSizeMapping,
	    refreshSlots: refreshSlots,
	    clearSlots: clearGPTSlots,
	    clearSlotTargeting: clearSlotTargeting,
	    destroySlots: destroyGPTSlots
	  };
	}();

	function _sendRequest(rocketeerSlots, requestOptions) {
	  /*
	            rOptions: {
	            sync: false,
	            syncSlots: [],
	            maintainCorrelator: true
	            };
	            */
	  return new promise$1(function (resolve) {
	    perf.mark('Sending Request Start');

	    _googleApi.configurePubAds().then(function () {
	      logger$1.log('pubads configured...');
	      var requestOpts = requestOptions || {
	        sync: false,
	        syncSlots: [],
	        maintainCorrelator: true
	      };
	      var displayedSlots = [];

	      var displaySlot = function displaySlot(slotId) {
	        _googleApi.executeWhenAvailable('displaying slot', function () {
	          logger$1.log('Displaying Slot: ' + slotId);

	          _googleApi.displaySlotById(slotId);
	        });
	      };

	      logger$1.log('Dispatching Slots: ', rocketeerSlots);

	      for (var i = 0; i < rocketeerSlots.length; i++) {
	        var slotId = rocketeerSlots[i].rktr_slot_id;

	        if (!document.getElementById(slotId)) {
	          logger$1.log("Can't Find Slot On Page", slotId);
	        } else {
	          // solve closure issue with slotId
	          if (_excludedSlotIds.indexOf(slotId) < 0 && !rocketeerSlots[i].displayed && _dispatchedSlots.indexOf(rocketeerSlots[i]) < 0) {
	            displaySlot(slotId);
	            rocketeerSlots[i].displayed = true;
	            displayedSlots.push(rocketeerSlots[i]);

	            _dispatchedSlots.push(rocketeerSlots[i]);
	          } else {
	            logger$1.log('Slot is excluded or already displayed. Not displaying: ', slotId);
	          }
	        }
	      }

	      if (!window.AdFuelUtils.getURLParam('enableInitialLoad')) {
	        var displayedSlotIds = displayedSlots.map(function (displayedSlot) {
	          return displayedSlot.rktr_slot_id;
	        });

	        _googleApi.executeWhenAvailable('refreshing slots', function () {
	          // all displayed slots must be refreshed to have their ad populated
	          // when syncing also include requestOptions.syncSlots
	          var slotsToRefresh = [];

	          keys$1(_pageSlots).forEach(function (slotDivId) {
	            // keep all slots or the ones matching requestOpts.syncSlots or the ones matching displayedSlotIds
	            logger$1.log('Checking Slot for Sync: ' + slotDivId);

	            if (requestOpts.sync && (!requestOpts.syncSlots || requestOpts.syncSlots.length === 0 || requestOpts.syncSlots.indexOf(slotDivId) >= 0) || displayedSlotIds.indexOf(slotDivId) >= 0) {
	              logger$1.log('Syncing Slot With Request: ' + slotDivId);
	              slotsToRefresh.push(_pageSlots[slotDivId]);
	            }
	          });

	          logger$1.log('Slots To Refresh: ', slotsToRefresh.map(function (slot) {
	            return slot ? slot.getSlotElementId() : 'NO ID';
	          }));

	          _googleApi.refreshSlots(slotsToRefresh);

	          perf.mark('Sending Request End');
	          perf.measure('Sending Request', 'Sending Request Start', 'Sending Request End');
	        });

	        requestOpts.maintainCorrelator = requestOpts.maintainCorrelator || true;
	        logger$1.log({
	          maintainCorrelator: requestOpts.maintainCorrelator
	        });
	      }

	      try {
	        var requestCompleteEvent = new CustomEvent('AdFuelRequestComplete', {
	          detail: {
	            slots: JSON.parse(stringify$1(displayedSlots)),
	            options: requestOptions
	          }
	        });
	        perf.mark('AdFuel Request Complete');
	        document.dispatchEvent(requestCompleteEvent);
	      } catch (ex) {
	        logger$1.error('error dispatching custom Event: AdFuelRequestComplete', {
	          error: ex
	        });
	      }

	      resolve(displayedSlots);
	    });
	  });
	}

	function setBulkTargeting(targeting) {
	  if (targeting) {
	    keys$1(targeting).forEach(function (key) {
	      if (key === 'slotTargets') {
	        keys$1(targeting[key]).forEach(function (key2) {
	          var targetGroup = targeting[key][key2];

	          keys$1(targetGroup).forEach(function (key3) {
	            AdFuel.addSlotLevelTarget(key2, key3, targeting[key][key2][key3]);
	          });
	        });
	      } else if (key === 'adTargets') {
	        keys$1(targeting[key]).forEach(function (key4) {
	          AdFuel.addPageLevelTarget(key4, targeting[key][key4]);
	        });
	      } else {
	        // For backwards compatibility
	        AdFuel.addPageLevelTarget(key, targeting[key]);
	      }
	    });
	  }
	}

	function _removeLeadingNumericNetworkId(adunit) {
	  // remove leading numeric networkId (ex:  8663477/CNN/Homepage)
	  var adUnitClone = adunit;

	  if (adUnitClone && adUnitClone.indexOf('/') >= 0) {
	    var nId = adUnitClone.split('/')[0];

	    if (_parseInt$2(nId, 10) > 0) {
	      var adUnitArray = adUnitClone.split('/');
	      adUnitArray.splice(0, 1);
	      adUnitClone = adUnitArray.join('/');
	    }
	  }

	  return adUnitClone;
	}

	function _addDebugListeners() {
	  window.AdFuelUtils.addEvent(document, 'AdFuelRequestComplete', function (e) {
	    logger$1.log('AdFuel Request Complete', {
	      requestEvent: e,
	      timestamp: new Date().toLocaleTimeString()
	    });
	  });
	  window.AdFuelUtils.addEvent(document, 'GPTRenderComplete', function (e) {
	    logger$1.log('GPT Render Complete', {
	      renderEvent: e,
	      timestamp: new Date().toLocaleTimeString(),
	      slot: e.detail.asset ? e.detail.asset.getSlotElementId() : 'NO ID'
	    });
	  });
	  window.AdFuelUtils.addEvent(document, 'SlotIdChange', function (e) {
	    logger$1.log('Slot ID Change', {
	      idChangeEvent: e,
	      timestamp: new Date().toLocaleTimeString()
	    });
	  });
	  window.AdFuelUtils.addEvent(document, 'SlotVisibilityChanged', function (e) {
	    logger$1.log('Slot Visibility Changed', {
	      visibilityChangedEvent: e,
	      timestamp: new Date().toLocaleTimeString()
	    });
	  });
	  window.AdFuelUtils.addEvent(document, 'SlotViewable', function (e) {
	    logger$1.log('Slot Viewable', {
	      viewableEvent: e,
	      timestamp: new Date().toLocaleTimeString(),
	      slot: e.detail.slot ? e.detail.slot.getSlotElementId() : 'NO ID'
	    });
	  });
	  window.AdFuelUtils.addEvent(document, 'GPTSlotLoaded', function (e) {
	    logger$1.log('Slot Loaded', {
	      slotOnLoadEvent: e,
	      timestamp: new Date().toLocaleTimeString(),
	      slot: e.detail.slot ? e.detail.slot.getSlotElementId() : 'NO ID'
	    });
	  });
	  window.AdFuelUtils.addEvent(document, 'PreQueueComplete', function (e) {
	    logger$1.log('PreQueueComplete', {
	      preQueueCompleteEvent: e,
	      timestamp: new Date().toLocaleTimeString()
	    });
	  });
	  window.AdFuelUtils.addEvent(document, 'PostQueueComplete', function (e) {
	    logger$1.log('PostQueueComplete', {
	      postQueueCompleteEvent: e,
	      timestamp: new Date().toLocaleTimeString()
	    });
	  });
	  window.AdFuelUtils.addEvent(document, 'PreDispatchComplete', function (e) {
	    logger$1.log('PreDispatchComplete', {
	      preDispatchCompleteEvent: e,
	      timestamp: new Date().toLocaleTimeString()
	    });
	  });
	  window.AdFuelUtils.addEvent(document, 'PostDispatchComplete', function (e) {
	    logger$1.log('PostDispatchComplete', {
	      postDispatchCompleteEvent: e,
	      timestamp: new Date().toLocaleTimeString()
	    });
	  });
	  window.AdFuelUtils.addEvent(document, 'PreRefreshComplete', function (e) {
	    logger$1.log('PreRefreshComplete', {
	      preRefreshCompleteEvent: e,
	      timestamp: new Date().toLocaleTimeString()
	    });
	  });
	  window.AdFuelUtils.addEvent(document, 'PostRefreshComplete', function (e) {
	    logger$1.log('PostRefreshComplete', {
	      postRefreshCompleteEvent: e,
	      timestamp: new Date().toLocaleTimeString()
	    });
	  });
	}

	function getFilterValue() {
	  return new promise$1(function (resolve) {
	    if (_blocked !== null) {
	      var consentRegion = window.AdFuelUtils.getUserConsentRegion();
	      var consentStatus = window.AdFuelUtils.getConsent();
	      UserConsentLogger ? UserConsentLogger.log("Consent already determined.  Region: ".concat(consentRegion, "  Status: ").concat(consentStatus)) : console.log("Consent already determined. Region: ".concat(consentRegion, " Status: ").concat(consentStatus));
	    } else {
	      _blocked = _isRegistryQueueable();
	    }

	    resolve(_blocked);
	  });
	}

	function receiveMessage(event) {
	  var currentLocation = document.location.protocol + '//' + document.location.hostname + ':' + document.location.port;

	  if (event.origin !== currentLocation) ; else {
	    try {
	      var payload = JSON.parse(event.data);

	      if (payload.action === 'getDivHeight') {
	        logger$1.log('Event Payload: ', payload);
	        var div = document.getElementById(payload.id);
	        var computedHeight = window.getComputedStyle(div, null).getPropertyValue('height');
	        var result = {
	          id: payload.id,
	          client: div.clientHeight,
	          offset: div.offsetHeight,
	          scroll: div.scrollHeight,
	          height: computedHeight
	        };
	        logger$1.log('Event Response: ', result);
	        event.source.postMessage(stringify$1({
	          source: 'adfuel',
	          action: 'returnDivHeight',
	          value: result
	        }));
	      }
	    } catch (err) {}
	  }
	}

	function checkForUserConsent(opts) {
	  if (opts.USER_CONSENT && opts.USER_CONSENT.ENABLED && (!window.WM || !window.WM.UserConsent)) {
	    UserConsentLogger.log('UserConsent is ENABLED but not present.');
	  } else if (window.WM && window.WM.UserConsent) {
	    UserConsentLogger.log('UserConsent is already present.');
	  } else {
	    UserConsentLogger.log('UserConsent is not enabled.');
	  }
	}

	function init$1(opts) {
	  // only occur once
	  siteOptions = opts;
	  _options = {
	    autoDispatch: siteOptions.ADFUEL.AUTO_DISPATCH,
	    defaultTimeout: window.AdFuelUtils.isMobile.any ? siteOptions.ADFUEL.DEFAULT_MOBILE_TIMEOUT || siteOptions.ADFUEL.DEFAULT_TIMEOUT : siteOptions.ADFUEL.DEFAULT_DESKTOP_TIMEOUT || siteOptions.ADFUEL.DEFAULT_TIMEOUT,
	    exclude: [],
	    siteObject: siteOptions.ADFUEL.SITE_OBJECT,
	    iframeTitle: siteOptions.ADFUEL.IFRAME_TITLE,
	    networkId: siteOptions.ADFUEL.NETWORK_ID,
	    refreshOnFocusOnly: siteOptions.ADFUEL.REFRESH_ON_FOCUS_ONLY
	  };

	  if (!_initialized) {
	    logger$1 = window.AdFuelUtils.getLogger(NAME$1, VERSION, 'adfuel', 'color: #4f86f7; padding: 2px', siteOptions && siteOptions.ADFUEL && siteOptions.ADFUEL.DEBUG || false);
	    UserConsentLogger = window.AdFuelUtils.getLogger(' User Consent', '', 'consent', 'color: coral; padding: 2px', siteOptions && siteOptions.USER_CONSENT && siteOptions.USER_CONSENT.DEBUG || false);
	    window.AdFuelUtils.setHostAndPathNames();
	    window.AdFuelUtils.setIsIntl();
	    checkForUserConsent(opts);
	    getFilterValue().then(function (shouldFilter) {
	      if (!shouldFilter) {
	        _initialized = true;
	        perf.mark('AdFuel Initialized');
	        window.addEventListener('message', receiveMessage, false);
	        if (window.AdFuelUtils.getURLParam('debug')) _addDebugListeners();

	        _setSlotRenderedClass();

	        logger$1.log('Checking for AdsQA...');

	        _checkForAdsQA();

	        logger$1.log('Binding dispatch to DOMContentLoaded and window.load...');

	        _bindReady();

	        _googleApi.executeWhenAvailable('set ad iframe title', _setAdIFrameTitle);

	        setTimeout(function () {
	          _queueDelayedRegistries();

	          _dispatchAllQueues();
	        }, 500);

	        try {
	          // trigger AdFuelCreated event, so pre-loaded modules can register
	          var adFuelCreatedWithConsentEvent = new CustomEvent('AdFuelCreated', {
	            detail: {
	              AdFuel: AdFuel
	            }
	          });
	          document.dispatchEvent(adFuelCreatedWithConsentEvent);
	        } catch (ex) {
	          logger$1.error('error dispatching custom Event: AdFuelCreated', {
	            error: ex
	          });
	        }
	      } else {
	        _dispatchAllQueues();

	        try {
	          // trigger AdFuelCreated event, so pre-loaded modules can register
	          var adFuelCreatedEvent = new CustomEvent('AdFuelCreated', {
	            detail: {
	              AdFuel: AdFuel
	            }
	          });
	          document.dispatchEvent(adFuelCreatedEvent);
	        } catch (ex) {
	          logger$1.error('error dispatching custom Event: AdFuelCreated', {
	            error: ex
	          });
	        }
	      }
	    });
	  }
	}

	function getQueuedSlots() {
	  return _queuedSlots;
	}

	function getSlotDetails(slotId) {
	  var matchingRocketeerSlot;

	  for (var i = 0; i < AdFuel.registry.length; i++) {
	    var reg = AdFuel.registry[i];

	    for (var j = 1; j < reg.length; j++) {
	      var rocketeerSlot = reg[j];

	      if (rocketeerSlot.rktr_slot_id === slotId) {
	        matchingRocketeerSlot = assign$1({}, rocketeerSlot);
	      }
	    }
	  }

	  var adUnitPath;
	  var slotTargeting = {};
	  var slot = _pageSlots[slotId];

	  if (slot) {
	    // get adUnit
	    adUnitPath = slot.getAdUnitPath(); // get targeting keys

	    var currentTargetingKeys = slot.getTargetingKeys();

	    keys$1(currentTargetingKeys).forEach(function (keyId) {
	      var keyName = currentTargetingKeys[keyId];
	      slotTargeting[keyName] = slot.getTargeting(keyName);
	    });
	  }

	  return {
	    adUnit: adUnitPath,
	    slot: matchingRocketeerSlot,
	    slotTargeting: slotTargeting
	  };
	}

	function registerModule(name, callbacks, version, options, monetizedOnly) {
	  getFilterValue().then(function (shouldFilter) {
	    if (shouldFilter) {
	      logger$1.log('User Consent Not Granted or Not Found. Not Registering Module.');
	    } else {
	      logger$1.log('Registering Module: ' + name + ' ' + version);
	      perf.mark('Registering Module: ' + name + ' ' + version);
	      var index = -1;

	      for (var i = 0; i < _registeredModules.length; i++) {
	        if (_registeredModules[i].name === name) {
	          index = i;
	        }
	      }

	      monetizedOnly = monetizedOnly || false;
	      version = version || 'Unspecified';
	      options = options || {};

	      if (callbacks.init) {
	        callbacks.init().then(function () {
	          if (index >= 0) {
	            // replace callbacks
	            _registeredModules[index] = {
	              name: name,
	              version: version,
	              callbacks: callbacks,
	              options: options,
	              monetized: monetizedOnly
	            };
	          } else {
	            // add module
	            _registeredModules.push({
	              name: name,
	              version: version,
	              callbacks: callbacks,
	              options: options,
	              monetized: monetizedOnly
	            });
	          }
	        });
	      } else {
	        if (index >= 0) {
	          // replace callbacks
	          _registeredModules[index] = {
	            name: name,
	            version: version,
	            callbacks: callbacks,
	            options: options,
	            monetized: monetizedOnly
	          };
	        } else {
	          // add module
	          _registeredModules.push({
	            name: name,
	            version: version,
	            callbacks: callbacks,
	            options: options,
	            monetized: monetizedOnly
	          });
	        }
	      }
	    }
	  });
	}

	function unregisterModule(name) {
	  // remove module, if it's found
	  var indexToRemove = -1;

	  for (var i = 0; i < _registeredModules.length; i++) {
	    if (_registeredModules[i].name === name) {
	      indexToRemove = i;
	    }
	  }

	  if (indexToRemove >= 0) {
	    _registeredModules.splice(indexToRemove, 1);
	  }
	}

	function setOptions(options) {
	  if (options) {
	    // apply options
	    if (options.exclude && options.exclude.length > 0) {
	      // add non-duplicating exclude slotIds
	      for (var i = 0; i < options.exclude.length; i++) {
	        var slotId = options.exclude[i];

	        if (_excludedSlotIds.indexOf(slotId) < 0) {
	          logger$1.log('Excluding Slot Id: ', slotId);

	          _excludedSlotIds.push(slotId);
	        }
	      }
	    }

	    keys$1(options).forEach(function (key) {
	      _options[key] = options[key];
	    });
	  }
	}

	var normalizeUrl = function _normalizeUrl(urlString) {
	  var options = assign$1({
	    normalizeProtocol: false,
	    normalizeHttps: true,
	    normalizeHttp: false,
	    stripFragment: true,
	    stripWWW: true,
	    removeQueryParameters: true,
	    removeTrailingSlash: true,
	    removeDirectoryIndex: false
	  }, {});

	  var urlStringInput = urlString.trim();
	  var hasRelativeProtocol = urlString[0] === '/' && urlString[1] === '/';
	  var isRelativeUrl = !hasRelativeProtocol && /^\.*\//.test(urlString); // Prepend protocol

	  if (!isRelativeUrl) {
	    urlStringInput = urlString.replace(/^(?!(?:\w+:)?\/\/)|^\/\//, 'http://');
	  }

	  var urlObj = document.createElement('a');
	  urlObj.href = urlStringInput;

	  if (options.normalizeHttps && options.normalizeHttp) {
	    throw new Error('The `normalizeHttp` and `normalizeHttps` options cannot be used together');
	  }

	  if (options.normalizeHttp && urlObj.protocol === 'http:') {
	    urlObj.protocol = 'https:';
	  }

	  if (options.normalizeHttps && urlObj.protocol === 'https:') {
	    urlObj.protocol = 'http:';
	  } // Remove fragment


	  if (options.stripFragment) {
	    urlObj.hash = '';
	  } // Remove duplicate slashes if not preceded by a protocol


	  if (urlObj.pathname) {
	    // TODO: Use the following instead when targeting Node.js 10
	    // `urlObj.pathname = urlObj.pathname.replace(/(?<!https?:)\/{2,}/g, '/');`
	    urlObj.pathname = urlObj.pathname.replace(/((?![https?:]).)\/{2,}/g, function _pathnameReplace(_, p1) {
	      if (/^(?!\/)/g.test(p1)) {
	        return p1 + '/';
	      }

	      return '/';
	    });
	  } // Decode URI octets


	  if (urlObj.pathname) {
	    urlObj.pathname = decodeURI(urlObj.pathname);
	  }

	  if (urlObj.hostname) {
	    // Remove trailing dot
	    urlObj.hostname = urlObj.hostname.replace(/\.$/, ''); // Remove `www.`

	    if (options.stripWWW) {
	      urlObj.hostname = urlObj.hostname.replace(/^www\./, '');
	    }
	  } // Remove query unwanted parameters


	  if (options.removeQueryParameters) {
	    urlObj.search = '';
	  } // Take advantage of many of the Node `url` normalizations


	  urlStringInput = urlObj.href; // Remove ending `/`

	  if (options.removeTrailingSlash || urlObj.pathname === '/') {
	    urlStringInput = urlString.replace(/\/$/, '');
	  } // Restore relative protocol, if applicable


	  if (hasRelativeProtocol && !options.normalizeProtocol) {
	    urlStringInput = urlString.replace(/^http:\/\//, '//');
	  }

	  return urlStringInput;
	};

	var AdFuel = {
	  init: init$1,
	  setOptions: setOptions,
	  addEvent: window.AdFuelUtils ? window.AdFuelUtils.addEvent : function () {},
	  dynamicTargeting: _dynamicTargeting,
	  setBulkTargeting: setBulkTargeting,
	  dispatchQueue: dispatchQueue,
	  queueRegistry: queueRegistry,
	  getQueuedSlots: getQueuedSlots,
	  getSlotDetails: getSlotDetails,
	  refresh: refresh,
	  destroySlots: destroySlots,
	  clearSlots: clearSlots,
	  removePageLevelTarget: removePageLevelTarget,
	  removeSlotLevelTarget: removeSlotLevelTarget,
	  addPageLevelTarget: addPageLevelTarget,
	  addSlotLevelTarget: addSlotLevelTarget,
	  registry: new RegistryArray(),
	  requestScriptText: '',
	  // module registration
	  registerModule: registerModule,
	  unregisterModule: unregisterModule,
	  registeredModules: _registeredModules,
	  // for debug
	  __VERSION__: function __VERSION__() {
	    return VERSION;
	  },
	  __OPTIONS__: function __OPTIONS__() {
	    return _options;
	  },
	  __CONFIG__: function __CONFIG__() {
	    return siteOptions;
	  },
	  rocketeerSlots: _rocketeerSlots,
	  pageSlots: _pageSlots,
	  builtSlots: _builtSlots,
	  queuedSlots: _queuedSlots,
	  cachedRegistries: _cachedRegistries // /////////////////////////////////////////////////

	};

	var callInit = function callInit() {
	  setTimeout(function () {
	    if (window.WM.UserConsent && window.WM.UserConsent.isReady()) {
	      initEventSet = window.WM.UserConsent.isOptanonLoaded() || false;

	      if (window.WM.UserConsent.getRegion() === 'ccpa') {
	        init$1(window.AdFuelOptions);
	      } else if (window.WM.UserConsent.getRegion() === 'gdpr') {
	        if (initEventSet) {
	          init$1(window.AdFuelOptions);
	        } else {
	          window.AdFuelUtils.addEvent(document, 'optanonLoaded', function () {
	            initEventSet = true;
	            init$1(window.AdFuelOptions);
	          });
	        }
	      } else {
	        init$1(window.AdFuelOptions);
	      }
	    }
	  }, 100);
	};

	if (window.AdFuelOptions) {
	  if (window.AdFuelOptions.USER_CONSENT.ENABLED) {
	    if (window.WM && window.WM.UserConsent && window.WM.UserConsent.isReady()) {
	      callInit();
	    } else {
	      window.AdFuelUtils.addEvent(document, 'userConsentReady', callInit);
	    }
	  } else {
	    init$1(window.AdFuelOptions);
	  }
	}

	return AdFuel;

}));
